var distanceTool = null;
var areaTool = null;
var drawTool = null;
var pointTool = null;
var point_box = null;
var mapTool = null;
var pointImage = '';
var lineTool = null;
var line_box = null;
var area_box = null;
var box_show = false;
var placeMarker = null;
var point_tips = null;
var line_tips = null;
var area_tips = null;
var areacountTool = null;
var areaNum = 0;
var selected = false;
var currentX = 107.70681;
var currentY = 35.97904;
var currentZ = 3;
var lastmap = false;
var x_pi = 3.14159265358979324 * 3000.0 / 180.0;
var lastcity = '';
var lasttime = (new Date()).getTime();
var request = "https://appmanage.17ditu.com";
var roadlayer = null;
var pointY = 50;
var roadshow = true;
var trafficshow = false;
var trafficlayer = null;
var token;
 var islng = true;
if (!getCookie('user')) {
	token = "0";
} else {
	token = JSON.parse(getCookie('user')).token;
	usertype = JSON.parse(getCookie('user')).viptype;
	userscore = JSON.parse(getCookie('user')).user.score;
	checkuservip();
}
setCookie("map", "");
var ms = "";
var currentMapId = 1;
var ac = null;
var posMarker;
var luopanMarker = null;
var luopanCrossMarker = null;
var isFangwei = false;
var isLuopan = false;
var isfollow = false;
var islocate = false;
var isgoogle = true;
var plusshow = true;
var coordinates = null;
var VIPcount = 0;
var mJson = $.ajax({
	url: "../manifest.json",
	async: false
});
var jsondata = JSON.parse(mJson.responseText);
var cversion = jsondata.version.name;
var lversion = getCookie('version');

var isos = false;
var hidedraw = false;
var coordlayer = null;
var coordshow = false;
var defaultlayer = null;
var projection;
var attribution;
$.ajax(request + '/dituapi/tool/getdefaultmap', {
	data: {

	},
	async: false,
	dataType: 'json', //服务器返回json格式数据
	type: 'post', //HTTP请求类型
	success: function(data) {
		var result = data;
		var urlTemplate;
		result.attribution = result.attribution.replace(/&amp;/g, "&");
		result.urlTemplate = result.urlTemplate.replace(/&amp;/g, "&");
		result.urlTemplate_road = result.urlTemplate_road.replace(/&amp;/g, "&");
		result.urlTemplate_traffic = result.urlTemplate_traffic.replace(/&amp;/g, "&");
		attribution = result.attribution;
		if (result.subdomains_road) {
			result.subdomains_road = result.subdomains_road.split(',');
		}
		projection = result.projection;

		if (result.urlTemplate_traffic) {
			if (result.subdomains_traffic) {
				result.subdomains_traffic = result.subdomains_traffic.split(',');
			}
			trafficlayer = new maptalks.TileLayer('实时路况', {
				'visible': false,
				'renderer': 'gl',
				'urlTemplate': result.urlTemplate_traffic,
				'subdomains': result.subdomains_traffic
			});
			$('#traffic').show();
			$('#traffic').prev().show();
		} else {
			trafficlayer = null;
		}
		if (result.name.indexOf('谷歌卫星') != -1) {
			isgoogle = true;
		} else {
			isgoogle = false;
		}
		if (result.name.indexOf('腾讯') != -1) {
			urlTemplate = function(t, e, i, a) {
				return getUrl({
					x: t,
					y: e,
					z: i,
					s: a,
					url: result.urlTemplate
				})
			};
		} else {
			urlTemplate = result.urlTemplate;
		};
		VIPcount = result.vip_count;
		
		var subdomains = [];
		if (result.subdomains) {
			subdomains = result.subdomains.split(',');
		};
		
		var cssFilter = result.css_filter;
		defaultlayer = new maptalks.TileLayer('卫星', {
			'urlTemplate': urlTemplate,
			'subdomains': subdomains,
			'renderer': 'gl',
			'cssFilter': cssFilter
		});
		
		if (result.urlTemplate_road) {
			$('#roadshow').show();
			roadlayer = new maptalks.TileLayer('显示路网', {
				'visible': true,
				'renderer': 'gl',
				'urlTemplate': result.urlTemplate_road,
				'subdomains': result.subdomains_road
			});
		} else {
			$('#roadshow').hide();
		}

	},
	error: function(error) {

	}
});

var map = null;
if (roadlayer && !trafficlayer) {
	map = new maptalks.Map('map', {
		center: [currentX, currentY],
		zoom: currentZ,
		spatialReference: {
			projection: projection
		},
		attribution: {
			content: attribution,
			position: {
				'bottom': "1",
				"right": "5"
			}
		},
		baseLayer: defaultlayer,
		layers: [roadlayer],
		devicePixelRatio: window.devicePixelRatio
	});
} else if (trafficlayer) {
	map = new maptalks.Map('map', {
		center: [currentX, currentY],
		zoom: currentZ,
		spatialReference: {
			projection: projection
		},
		attribution: {
			content: attribution,
			position: {
				'bottom': "1",
				"right": "5"
			}
		},
		baseLayer: defaultlayer,
		layers: [roadlayer, trafficlayer],
		devicePixelRatio: window.devicePixelRatio
	});
} else {
	map = new maptalks.Map('map', {
		center: [currentX, currentY],
		zoom: currentZ,
		spatialReference: {
			projection: projection
		},
		attribution: {
			content: attribution,
			position: {
				'bottom': "1",
				"right": "5"
			}
		},
		baseLayer: defaultlayer,
		devicePixelRatio: window.devicePixelRatio
	});
}






//初始化按钮组
function initcontrolbar() {
	var buttons = document.querySelectorAll('#controlbar button');
	for (var i = 0; i < buttons.length; i++) {
		buttons[i].className = 'btn';
		buttons[i].style.display = 'block';
	};
};

String.prototype.format = function(t) {
	var e = this;
	if (arguments.length > 0)
		if (true) {
			for (var i in t)
				if (void 0 != t[i]) {
					var a = new RegExp("({" + i + "})", "g");
					e = e.replace(a, t[i])
				}
		} else
			for (var o = 0; o < arguments.length; o++)
				if (void 0 != arguments[o]) {
					a = new RegExp("({[" + o + "]})", "g");
					e = e.replace(a, arguments[o])
				};
	return e;
};

function getUrl(t) {
	var e = t.x,
		i = t.y,
		a = t.z,
		o = t.s,
		n = t.url;
	return i = Math.pow(2, a) - 1 - i,
		n.format({
			s: o,
			z: a,
			x: e,
			y: i,
			x16: parseInt(e / 16),
			y16: parseInt(i / 16)
		});
};

function checkuservip() {
	$.ajax({
		type: "post",
		url: request + "/user/profile/checksvip",
		async: true,
		data: {
			token: token
		},
		success: function(data) {
			data = JSON.parse(data);
			usertype = data.viptype;
		}
	});
}

function checkvip(vip) {
	vip = vip + 1;
	
	
	if (usertype == "0" && vip != 1) {
		layer.confirm('想要浏览该地图,现在登录？', {
			btn: ['去登录', '算了'] //按钮
		}, function() {
			window.location.href = "../user/login.html";
		}, function() {

		});
		return false;
	};
	
	if (vip > usertype && usertype != 0) {
		layer.confirm('VIP专属地图，升级为VIP后可以使用。', {
				btn: ['马上升级', '算了'], //按钮，
				title: "温馨提示"
			},
			function() {
				window.location.href = "../user/pay/index.html";
			},
			function() {

			});
		return;
	}
	return true;
};
var drawtitle = "";
var drawdes = "";

window.getAPPmap = function(id, vip, event) {
	coordshow = false;
	$('#showarea').hide();
	$('#showarea')[0].nextElementSibling.style.display = 'none';
	if(event.target.textContent.indexOf('谷歌卫星') != -1) {
		isgoogle = true;
	} else {
		isgoogle = false;
	}
	
	vip = vip + 1;
	get_map(id);
	closeleft();
}

function get_map(mapid, mapdata) {
	islocate = false;
	var requesturl = "/dituapi/tool/getmap";

	$.post(request + requesturl, {
			'mapid': mapid
		},
		function(result) {
			if (!result) {
				layer.msg('获取地图信息失败');
				hideonlinemap();
				initbuttom();
				return;
			}
			result = JSON.parse(result);
			
			if (result.name.indexOf('谷歌卫星') == -1 && !checkvip(result.vip_count)) {
				return;
			};
			if (result.name.indexOf('谷歌卫星') != -1) {
				isgoogle = true;
			} else {
				isgoogle = false;
			}
			VIPcount = result.vip_count;
			
			if (result.name.indexOf('百度') != -1) {
				setCookie('map', 'baidu');
			} else {
				setCookie('map', '');
			}
			currentMapId = mapid;
			//由于设置地图的时候回存在编码问题，所以需要进行处理
			result.attribution = result.attribution.replace(/&amp;/g, "&");
			result.urlTemplate = result.urlTemplate.replace(/&amp;/g, "&");
			result.urlTemplate_road = result.urlTemplate_road.replace(/&amp;/g, "&");
			result.urlTemplate_traffic = result.urlTemplate_traffic.replace(/&amp;/g, "&");

			var projection = null;
			trafficlayer = null;
			roadlayer = null;
			trafficshow = false;
			maxzoom = parseInt(result.maxzoom);
			minzoom = parseInt(result.minzoom);
			cssFilter = result.css_filter;
			initcontrolbar();
			projection = result.projection;
			mt = result.id;
			var url = "";
			if (areaId != "") {
				url = "/map/" + areaId + ".html&mt=" + mt + "&ms=" + ms;
			} else {
				url = "?mt=" + mt + "&ms=" + ms;
				setStates(result.title, url);
			};

			if (isgoogle) {
				$('#adddiscoverybtn').show();
			} else {
				$('#adddiscoverybtn').hide();
			}

			if (result.name.indexOf('百度') != -1) {

				//百度坐标系跟其他坐标系转换
				var point = {
					"lng": currentX,
					"lat": currentY
				};
				lastmap = true;
				var newP = Convert_GCJ02_To_BD09(point);
				currentX = newP.lng;
				currentY = newP.lat;
				var subdomains_traffic = [];
				if (result.subdomains_traffic) {
					subdomains_traffic = result.subdomains_traffic.split(',');
				};
				trafficlayer = new maptalks.TileLayer('实时路况', {
					'visible': false,
					'renderer': 'gl',
					'urlTemplate': result.urlTemplate_traffic,
					'subdomains': subdomains_traffic
				});
				$('#traffic').show();
				$('#traffic').prev().show();
			} else {

				$('#traffic').hide();
				$('#traffic').prev().hide();
				if (lastmap) {
					var point = {
						"lng": currentX,
						"lat": currentY
					};
					var newP = Convert_BD09_To_GCJ02(point);
					currentX = newP.lng;
					currentY = newP.lat;
				}
				lastmap = false;
			};
			var urlTemplate;
			if (result.name.indexOf('腾讯') != -1) {
				urlTemplate = function(t, e, i, a) {
					return getUrl({
						x: t,
						y: e,
						z: i,
						s: a,
						url: result.urlTemplate
					})
				};
			} else {
				urlTemplate = result.urlTemplate;
			};

			var subdomains = [];
			if (result.subdomains) {
				subdomains = result.subdomains.split(',');
			};

			if (result.urlTemplate_road) {
				$('#roadshow').show();
				var subdomains_road = []
				if (result.subdomains_road) {
					subdomains_road = result.subdomains_road.split(',');
				}
				var urlTemplate_road;
				if (result.name.indexOf('腾讯') != -1) {
					urlTemplate_road = function(t, e, i, a) {
						return getUrl({
							x: t,
							y: e,
							z: i,
							s: a,
							url: result.urlTemplate_road
						});
					};
				} else {
					urlTemplate_road = result.urlTemplate_road;
				};
				if (areaId != "" || roadshow) {
					roadlayer = new maptalks.TileLayer('显示路网', {
						'visible': true,
						'renderer': 'gl',
						'urlTemplate': urlTemplate_road,
						'maxZoom': maxzoom,
						'minZoom': minzoom,
						'subdomains': subdomains_road
					});
					roadshow = true;
					$('#road').addClass('active');
					$('#road').attr('checked', 'checked');
				} else {
					roadlayer = new maptalks.TileLayer('显示路网', {
						'visible': false,
						'renderer': 'gl',
						'urlTemplate': urlTemplate_road,
						'maxZoom': maxzoom,
						'minZoom': minzoom,
						'subdomains': subdomains_road
					});
				};

				var baselayer = new maptalks.TileLayer(
					'卫星', {
						'urlTemplate': urlTemplate,
						'subdomains': subdomains,
						'maxZoom': maxzoom,
						'minZoom': minzoom,
						'renderer': 'gl',
						'cssFilter': cssFilter
					});
				set_map(baselayer, projection, result.attribution, trafficlayer, maxzoom, minzoom, roadlayer);
			} else {
				$('#roadshow').hide();
				var baselayer = new maptalks.TileLayer(
					'卫星', {
						'urlTemplate': urlTemplate,
						'subdomains': subdomains,
						'maxZoom': maxzoom,
						'minZoom': minzoom,
						'renderer': 'gl',
						'cssFilter': cssFilter
					});
				set_map(baselayer, projection, result.attribution, trafficlayer, maxzoom, minzoom, roadlayer);
			};

			if (areaId != "" && isDirectOpen != "0") {

				if (coordinates && coordinates != "" && coordinates != "null") {
					coordpolygon = new maptalks.Polygon(coordinates, {
						visible: true,
						editable: true,
						cursor: 'pointer',
						shadowBlur: 0,
						shadowColor: 'black',
						draggable: false,
						dragShadow: false,
						// display a shadow during dragging
						drawOnAxis: null,
						// force dragging stick on a axis, can be: x, y
						symbol: {
							'lineColor': '#00BFFF',
							'lineWidth': 5,
							'polygonFill': '#FF7F24',
							'polygonOpacity': 0
						}
					});

					coordlayer = new maptalks.VectorLayer('地区边界', coordpolygon).addTo(map);
					coordshow = false;
					$('#showarea').show();
					$('#showarea').removeAttr('checked');
					$('#showarea')[0].nextElementSibling.style.display = 'inline';
					coordpolygon.flash(500, //flash interval in ms
						3, // count
						function() { // callback when flash end
							coordlayer.hide();
							if (lng != "") {
								var positionTips = {
									'title': '当前位置',
									'content': cityName,
									'autoOpenOn': '',
									'width': 200
								};
								var infoWindow = new maptalks.ui.InfoWindow(positionTips);
								infoWindow.addTo(map).show(coord);
							};
						});
				} else {
					if (lng != "") {
						var positionTips = {
							'title': '当前位置',
							'content': cityName,
							'autoOpenOn': '',
							'width': 200
						};
						var infoWindow = new maptalks.ui.InfoWindow(positionTips);
						infoWindow.addTo(map).show(coord);
					};
				};
			};
			if (mapdata) {
				drawtitle = mapdata.title;
				drawdes = mapdata.des;
				set_darw_collectiom(mapdata);
			}
		});
}

function setStates(title, url) {
	return;
};

function Convert_BD09_To_GCJ02(point) {
	var x = point.lng - 0.0065,
		y = point.lat - 0.006;
	var z = Math.sqrt(x * x + y * y) - 0.00002 * Math.sin(y * x_pi);
	var theta = Math.atan2(y, x) - 0.000003 * Math.cos(x * x_pi);
	point.lng = (z * Math.cos(theta)).toFixed(5);
	point.lat = (z * Math.sin(theta)).toFixed(5);
	return point;
};

function Convert_GCJ02_To_BD09(point) {
	var x = point.lng,
		y = point.lat;
	var z = Math.sqrt(x * x + y * y) + 0.00002 * Math.sin(y * x_pi);
	var theta = Math.atan2(y, x) + 0.000003 * Math.cos(x * x_pi);
	point.lng = (z * Math.cos(theta) + 0.0065).toFixed(5);
	point.lat = (z * Math.sin(theta) + 0.006).toFixed(5);
	return point;
};

//设置地图
function set_map(baseLayer, projection, attribution, trafficlayer, maxzoom, minzoom, roadlayer) {
	if (map) {
		map.remove();
	}

	if (roadlayer) {
		//是否有实时交通数据
		if (!trafficlayer) {
			map = new maptalks.Map('map', {
				center: [currentX, currentY],
				zoom: currentZ,
				maxZoom: maxzoom,
				minZoom: minzoom,
				spatialReference: {
					projection: projection
				},
				attribution: {
					content: attribution,
					position: {
						'bottom': "1",
						"right": "5"
					}
				},
				baseLayer: baseLayer,
				layers: [roadlayer],
				devicePixelRatio: window.devicePixelRatio
			});
		} else {
			map = new maptalks.Map('map', {
				center: [currentX, currentY],
				zoom: currentZ,
				maxZoom: maxzoom,
				minZoom: minzoom,
				spatialReference: {
					projection: projection
				},
				attribution: {
					content: attribution,
					position: {
						'bottom': "1",
						"right": "5"
					}
				},
				baseLayer: baseLayer,
				layers: [roadlayer, trafficlayer],
				devicePixelRatio: window.devicePixelRatio
			});
		}
	} else {
		//是否有实时交通数据
		if (!trafficlayer) {
			map = new maptalks.Map('map', {
				center: [currentX, currentY],
				zoom: currentZ,
				maxZoom: maxzoom,
				minZoom: minzoom,
				spatialReference: {
					projection: projection
				},
				attribution: {
					content: attribution,
					position: {
						'bottom': "1",
						"right": "5"
					}
				},
				baseLayer: baseLayer,
				devicePixelRatio: window.devicePixelRatio
			});
		} else {
			map = new maptalks.Map('map', {
				center: [currentX, currentY],
				zoom: currentZ,
				maxZoom: maxzoom,
				minZoom: minzoom,
				spatialReference: {
					projection: projection
				},
				attribution: {
					content: attribution,
					position: {
						'bottom': "1",
						"right": "5"
					}
				},
				baseLayer: baseLayer,
				layers: [trafficlayer],
				devicePixelRatio: window.devicePixelRatio
			});
		}
	}

	map.on('click', mapclick);
	map.on('moveend zoomend', update);
	map.on('moving', updateMoving);
	map.on('dragrotating', rotating);
	update();
	addTools();
	addCross();
	map.on('contextmenu',
		function(e) {
			rightClick(e.coordinate);
		});
	var imperial = new maptalks.control.Scale({
		'position': {
			'bottom': '25',
			'right': '5'
		},
		'maxWidth': 100,
		'metric': true,
		'imperial': false
	});
	map.addControl(imperial);
	if (isLuopan) {
		$('#luopanbtn').addClass('active');
		showluopan();
	}
	if (isFangwei) {
		$('#fangweibtn').addClass('active');
		showfangwei();
	}
};

//罗盘透明度
$("#luopanopacity").slider({
			orientation: "horizontal",
			range: "min",
			max: 10,
			value: 10,
			min: 2,
			slide: refreshluopanOpacity
});
function refreshluopanOpacity(){
	if (luopanMarker) {
		luopanMarker.updateSymbol({
			'markerOpacity': $("#luopanopacity").slider('value')/10
		});
		luopanCrossMarker.updateSymbol({
			'markerOpacity': $("#luopanopacity").slider('value')/10
		});
	}
}

function rotating(event) {
	if (posMarker) {
		posMarker.updateSymbol({
			'markerRotation': map.getBearing()
		});
	}
	if (luopanMarker) {
		luopanMarker.setCoordinates(map.getCenter());
		luopanCrossMarker.setCoordinates(map.getCenter());
		luopanMarker.updateSymbol({
			'markerRotation': -currentDec() + map.getBearing()
		});
		$("#mageLat").text(currentX);
		$("#mageLng").text(currentY);
		$("#magedir").text(currentDec());
	}
};
$('#traffic').click(function() {
	if (trafficlayer && !trafficshow) {
		trafficshow = true;
		trafficlayer.show();
	} else if (trafficlayer && trafficshow) {
		trafficshow = false;
		trafficlayer.hide();
	};
});
$('#point_control').click(function() {
	if (canvasLayer && plusshow) {
		plusshow = false;
		canvasLayer.hide();
	} else if (canvasLayer && !plusshow) {
		plusshow = true;
		canvasLayer.show();
	};
});
$('#road').click(function() {
	if (roadlayer && !roadshow) {
		map.setCenter([currentX, currentY]);
		roadshow = true;
		roadlayer.show();
	} else if (roadlayer && roadshow) {
		roadshow = false;
		roadlayer.hide();
		map.setCenter([currentX, currentY]);
	};
});
$('#redcross').click(function() {
	if (canvasLayer && plusshow) {
		plusshow = false;
		canvasLayer.hide();
	} else if (canvasLayer && !plusshow) {
		plusshow = true;
		canvasLayer.show();
	}
});
$('#showarea').click(function() {
	if (coordlayer && coordshow) {
		coordshow = false;
		coordlayer.hide();
	} else if (coordlayer && !coordshow) {
		coordshow = true;
		coordlayer.show();
	}
});
var imperial = new maptalks.control.Scale({
	'position': {
		'bottom': '25',
		'right': '5'
	},
	'maxWidth': 100,
	'metric': true,
	'imperial': false
});

map.addControl(imperial);
$("#zoomup").on("click", function() {
	map.zoomIn();
});
$("#zoomdown").on("click", function() {
	map.zoomOut();
});



function showfangwei() {
	isFangwei = true;
	posMarker.addTo(posLayer);
	posMarker.setCoordinates(map.getCenter());
	canvasLayer.hide();
	$('#redcross').removeAttr('checked');
	plusshow = false;
	isLuopan = false;
	$('#luopaninfo').css('display', 'none');
	$('#showluopan').hide();
	$('#luopanbtn').removeClass('active');
	luopanMarker.remove();
	luopanCrossMarker.remove();
}

function hidefangwei() {
	isFangwei = false;
	if (!islocate) {
		canvasLayer.show();
		$('#redcross').prop("checked", true);
		plusshow = true;
	}
	posMarker.remove();
}
document.getElementById("fangweibtn").onclick = function() {
	if (!isFangwei) {
		showfangwei();
	} else {
		hidefangwei();
	}
};

function hideluopan() {
	isLuopan = false;
	$('#luopaninfo').css('display', 'none');
	$('#showluopan').hide();
	if (!islocate) {
		canvasLayer.show();
		$('#redcross').prop("checked", true);
		plusshow = true;
	}
	luopanMarker.remove();
	luopanCrossMarker.remove();
}

function showluopan() {
	isLuopan = true;
	luopanMarker.addTo(luopanLayer);
	luopanCrossMarker.addTo(luopanLayer);
	luopanMarker.setCoordinates(map.getCenter());
	luopanCrossMarker.setCoordinates(map.getCenter());
	canvasLayer.hide();
	$('#showluopan').show();
	$('#redcross').removeAttr('checked');
	plusshow = false;
	isFangwei = false;
	posMarker.remove();
	$('#fangweibtn').removeClass('active');
	$("#mageLat").text(currentX);
	$("#mageLng").text(currentY);
	$("#magedir").text(currentDec());
	luopanCrossMarker.updateSymbol({
		'markerRotation': 0
	});
	luopanMarker.updateSymbol({
		'markerRotation': -currentDec() + map.getBearing()
	});
}

document.getElementById("luopanbtn").onclick = function() {
	if (!isLuopan) {
		showluopan();
		$('#showluopan').show();
	} else {
		hideluopan();
		$('#showluopan').hide();
	}
};

function hidecontrolbtn() {

	var show = $('#controlbar').css('display');
	if (show == "block") {
		$('#controlbar').css('display', "none");
		$('#showbtn').show();
	} else {
		$('#controlbar').css('display', "block");
		$('#showbtn').hide();
	}
}

function exportpicClick() {
	if (usertype == "0") {
		layer.confirm('登录后可以导出图片，现在登录？', {
			btn: ['去登录', '算了'] //按钮
		}, function() {
			window.location.href = "../user/login.html";
		}, function() {

		});
	} else {
		save();
	}
}


function save() {
	plus.nativeUI.showWaiting();
	var canvas = document.querySelector('.maptalks-canvas-layer canvas');
	var imgurl = canvas.toDataURL();
	var url = '17ditu' + '_' + new Date().getTime() + '.png';
	$.post(request + "/dituapi/tool/savecoverimg", {
		"imgdata": imgurl,
		'img': url,
		'width': canvas.offsetWidth,
		'height': canvas.offsetHeight
	}, function(res) {
		if (res != 1111 && res) {
			var imgURL = request + '/upload/' + res
			var self = plus.webview.currentWebview();
			var dtask = plus.downloader.createDownload(imgURL, {}, function(d, status) {
				// 下载完成
				if (status == 200) {
					plus.gallery.save(d.filename, function() { //保存到相册方法
						plus.nativeUI.closeWaiting()
						plus.nativeUI.alert('下载成功，已️保存到手机相册', null, '下载');
						delete_canvasimg(res);
					}, function() {
						plus.nativeUI.closeWaiting()
						plus.nativeUI.alert('下载失败！', null, '下载');
					});
				} else {
					plus.nativeUI.closeWaiting()
					plus.nativeUI.alert('下载失败！', null, '下载');
				}
			});
			dtask.start();
		}
	});

};

function delete_canvasimg(imgurl) {
	$.ajax({
		type: "post",
		url: request + "/dituapi/tool/delete_canvasimg",
		async: true,
		data: {
			imgurl: imgurl
		},
		success: function(data) {}
	});

}

//添加新发现
function adddiscoverybtnClick() {
	$.post(request + "/dituapi/tool/select", {},
		function(result) {
			if (result) {
				result = JSON.parse(result);
				var select = '<select id="category" style="width:80%" name="category_id" class="form-control">';
				for (var i = 0; i < result.length; i++) {
					if (i == result.length - 1) {
						select += "<option selected='selected' value='" + result[i].cid + "'>" + result[i].category_name + "</option>";
					} else {
						select += "<option value='" + result[i].cid + "'>" + result[i].category_name + "</option>";
					}
				}
				select += '</select>';

				if (usertype == "0") {
					layer.confirm('添加地图发现需要登录,现在登录？', {
						btn: ['去登录', '算了'] //按钮
					}, function() {
						window.location.href = "../user/login.html";
					}, function() {});
				} else {
					layerIndex2 = layer.open({
						type: 1,
						area: ['300px', '342px'],
						fix: false,
						//不固定
						maxmin: false,
						shade: 0.4,
						anim: 3,
						shadeClose: true,
						//开启遮罩关闭
						title: '地图发现',
						closeBtn: false,
						'content': '<div class="panel-body">' + '<div class="form form-horizontal"  style="padding:10px">' +
							'<span>每次提交地图发现需要扣除<span style="color:blue">10</span>个<span title="可以通过签到、充值等方式获取">图币</span>。<br/>' +
							'<span style="color:green">通过审核</span>返还<span style="color:green">20</span>个图币。<br/>' +
							'<span style="color:red">未通过审核</span>返还<span style="color:red">5</span>个图币。<br/>' +
							'<span style="font-weight:bold">通过审核的地图发现每获得一个赞可以得到1个图币。赶快提交吧！</span>' +
							'</span>' +
							'<div class="text-center">分类：' + select + '</div> ' +
							'<div class="text-center" style="padding-top:10px;" >描述：' +
							'<input type="text" style="width:80%;" id="discoveryDescription" placeholder="描述该发现，不超过12字"  maxlength="12"  class="form-control radius size-M" >' +
							'</div>' +
							'<div class="row cl">' + '</div> ' +
							'<div class="text-center"  style="text-align:center;padding-top:10px" >' +
							'<input class="btn btn-success radius" type="button" onclick="submitDiscovery()" value="提交发现">' +
							'<input class="btn btn-danger radius" style="margin-left:20px;" type="button" onclick="layer.close(layerIndex2)" value="关闭">' +
							'</div> ' + '</div>' + '</div>',
					});
				}
			} else {
				layer.msg('获取数据失败');
			}
		});
	return;

};
//提交发现
function submitDiscovery() {
	if (plusshow) {
		canvasLayer.hide();
	}
	if (isfollow) {
		posMarker.remove();
	}
	setTimeout(function() {
		var canvas = document.querySelector('.maptalks-canvas-layer canvas');
		var clip = document.getElementById('saveimg');
		clip.setAttribute('width', 400)
		clip.setAttribute('height', 400)
		var context_clip = clip.getContext('2d');
		var context = canvas.getContext('2d');
		canvas.crossOrigin = "";
		//裁剪图像
		var clipImg = context.getImageData(canvas.offsetWidth / 2 - 200, canvas.offsetHeight / 2 - 200, 400, 400)
		var set = context_clip.putImageData(clipImg, 0, 0, 0, 0, 400, 400);
		var imgurl = clip.toDataURL();
		var desp = document.getElementById("discoveryDescription").value;
		if (desp == "") {
			layer.tips('描述不能为空!', '#discoveryDescription', {
				tips: [1, '#3595CC'],
				time: 2000
			});
			return;
		};
		if (userscore < 10) {
			layer.msg('图币不足!', {
				icon: 0
			});
			return;
		}
		var index = layer.load(1, {
			shade: [0.1, '#fff'] //0.1透明度的白色背景
		});
		var geoc = new BMap.Geocoder();
		var address = "";
		var point = new BMap.Point(currentX, currentY);
		var url = '17ditu' + '_' + new Date().getTime() + '.png';
		var category = document.getElementById("category").value;
		$.post(request + "/dituapi/tool/savecover", {
			"imgdata": imgurl,
			'img': url
		}, function(res) {
			if (res != '1111' && res) {
				geoc.getLocation(point,
					function(rs) {
						var addComp = rs.addressComponents;
						address = addComp.province + addComp.city + addComp.district + addComp.street + addComp.streetNumber;
						$.ajax({
							type: "post",
							url: request + "/discovery/tool/add",
							async: true,
							data: {
								"lat": currentY,
								"lng": currentX,
								"zoom": currentZ,
								"address": address,
								"description": desp,
								'img_url': res,
								'category': category,
								token: token
							},
							xhrFields: {
								withCredentials: true
							},
							crossDomain: true,
							success: function(result) {
								if (plusshow) {
									canvasLayer.show();
								}
								if (isfollow) {
									posMarker.addTo(posLayer);
								}
								if (result == "1") {
									layer.close(layerIndex2);
									layer.close(index);
									layer.msg('地图发现提交成功,审核完成后就可以展示了!', {
										icon: 1
									});
								} else if (result == "2") {
									layer.close(index);
									layer.msg('图币不足!', {
										icon: 0
									});
								} else {
									layer.close(index);
									layer.msg('地图发现提交失败!', {
										icon: 0
									});
								}
							}
						});

					});
			} else {
				layer.close(index);
				layer.msg('封面生成失败，请重新提交');
			}
		})
	}, 100);
};

// document.getElementById("followbtn").onclick = function() {

// 	if(!isfollow) {
// 		isfollow = true;
// 		posMarker.addTo(posLayer);
// 		canvasLayer.hide();
// 		$('#point_control').removeClass('active');
// 		plusshow = false;
// 	} else {
// 		isfollow = false;
// 		if(!islocate) {
// 			canvasLayer.show();
// 			$('#point_control').addClass('active');
// 			plusshow = true;
// 		}
// 		posMarker.remove();
// 	}
// };

function rightClick(coordinate) {
	var options = {
		'items': [{
				item: '这是哪儿',
				click: function(e) {
					var geoc = new BMap.Geocoder();
					var address = "";
					var point;
					if (getCookie("map") == "baidu") {
						point = new BMap.Point(coordinate.x, coordinate.y);
					} else {
						var p = {
							"lng": coordinate.x,
							"lat": coordinate.y
						};
						var newP = Convert_GCJ02_To_BD09(p);
						point = new BMap.Point(newP.lng, newP.lat);
					}

					geoc.getLocation(point,
						function(rs) {
							var addComp = rs.addressComponents;
							address = addComp.province + "  " + addComp.city + "  " + addComp.district + "  " + addComp.street + "  " +
								addComp.streetNumber;
							var positionTips = {
								'title': '当前位置',
								'content': "坐标：" + point.lng.toFixed(5) + "," + point.lat.toFixed(5) + "<br />地址：" + address,
								'autoOpenOn': '',
								'width': 220
							};
							var infoWindow = new maptalks.ui.InfoWindow(positionTips);
							infoWindow.addTo(map).show(coordinate);
						});
				}
			},
			{
				item: '设为地图中心点',
				click: function(e) {
					currentX = coordinate.x;
					currentY = coordinate.y;
					map.panTo([currentX, currentY]);
				}
			},
			'-', {
				item: 'Version Fgis v1.0 beta',
				click: function(e) {
					e.stopPropagation;
					return false;
				}
			}
		]
	};
	map.setMenu(options).openMenu(coordinate);
};
//更新方位图坐标
function updateMoving() {
	if (posMarker && isFangwei) {
		posMarker.setCoordinates(map.getCenter());
		posMarker.updateSymbol({
			'markerRotation': map.getBearing()
		});
	}
	if (luopanMarker && isLuopan) {
		var currentDecValue = currentDec();
		luopanMarker.setCoordinates(map.getCenter());
		luopanCrossMarker.setCoordinates(map.getCenter());
		luopanMarker.updateSymbol({
			'markerRotation': -currentDecValue + map.getBearing()
		});
		$("#mageLat").text(currentX);
		$("#mageLng").text(currentY);
		$("#magedir").text(currentDecValue);
	}
};

function addCross() {
	if (map.getLayer('显示光标')) {
		map.getLayer('显示光标').remove();
	}

	canvasLayer = new maptalks.CanvasLayer('显示光标', {
		'forceRenderOnMoving': true,
		'forceRenderOnZooming': true
	});

	// param1 and param2 are prepareToDraw's return values.
	canvasLayer.draw = function(context, view, param1, param2) {
		var size = map.getSize();
		var str = "+";
		var len = context.measureText(str);
		context.fillStyle = '#f00';
		context.font = ' 50px MicrosoftYahei';
		context.fillText(str, size.width / 2 - 18, size.height / 2 + 18);
		this.completeRender();
	};

	//draw when map is interacting
	canvasLayer.drawOnInteracting = function(context, view, param1, param2) {
		this.draw(context, view, param1, param2);
	};

	map.addLayer(canvasLayer);
	$('#redcross').prop("checked", true);
	//如果上一次建立的vectorcollect存在，则移除它，否则会影响标注操作
	if (map.getLayer('方位图')) {
		map.getLayer('方位图').remove();
	}
	posLayer = new maptalks.VectorLayer('方位图').addTo(map);
	posMarker = new maptalks.Marker(map.getCenter(), {
		'symbol': {
			'markerFile': '../static/images/direction.png',
			'markerWidth': 200,
			'markerHeight': 200,
			'markerDx': 0,
			'markerDy': 100,
			'markerOpacity': 1
		}

	});

	if (map.getLayer('罗盘')) {
		map.getLayer('罗盘').remove();
	}

	luopanLayer = new maptalks.VectorLayer('罗盘').addTo(map);
	luopanMarker = new maptalks.Marker(map.getCenter(), {
		'symbol': {
			'markerFile': '../static/images/compass.png',
			'markerWidth': 320,
			'markerHeight': 320,
			'markerDx': 0,
			'markerDy': 160,
			'markerOpacity': 1,
			'markerRotation': 0
		}
	});
	luopanCrossMarker = new maptalks.Marker(map.getCenter(), {
		'symbol': {
			'markerFile': '../static/images/crossline.png',
			'markerWidth': 320,
			'markerHeight': 320,
			'markerDx': 0,
			'markerDy': 160,
			'markerOpacity': 1,
			'markerRotation': 0
		}
	});
};
//由于引入figjs会导致冲突，故重新封装base64对象
function Base64() {
	// private property  
	var _keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	// public method for encoding  
	this.encode = function(input) {
		var output = "";
		var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
		var i = 0;
		input = _utf8_encode(input);
		while (i < input.length) {
			chr1 = input.charCodeAt(i++);
			chr2 = input.charCodeAt(i++);
			chr3 = input.charCodeAt(i++);
			enc1 = chr1 >> 2;
			enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
			enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
			enc4 = chr3 & 63;
			if (isNaN(chr2)) {
				enc3 = enc4 = 64;
			} else if (isNaN(chr3)) {
				enc4 = 64;
			}
			output = output +
				_keyStr.charAt(enc1) + _keyStr.charAt(enc2) +
				_keyStr.charAt(enc3) + _keyStr.charAt(enc4);
		}
		return output;
	}

	// public method for decoding  
	this.decode = function(input) {
		var output = "";
		var chr1, chr2, chr3;
		var enc1, enc2, enc3, enc4;
		var i = 0;
		input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
		while (i < input.length) {
			enc1 = _keyStr.indexOf(input.charAt(i++));
			enc2 = _keyStr.indexOf(input.charAt(i++));
			enc3 = _keyStr.indexOf(input.charAt(i++));
			enc4 = _keyStr.indexOf(input.charAt(i++));
			chr1 = (enc1 << 2) | (enc2 >> 4);
			chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
			chr3 = ((enc3 & 3) << 6) | enc4;
			output = output + String.fromCharCode(chr1);
			if (enc3 != 64) {
				output = output + String.fromCharCode(chr2);
			}
			if (enc4 != 64) {
				output = output + String.fromCharCode(chr3);
			}
		}
		output = _utf8_decode(output);
		return output;
	}

	// private method for UTF-8 encoding  
	_utf8_encode = function(string) {
		string = string.replace(/\r\n/g, "\n");
		var utftext = "";
		for (var n = 0; n < string.length; n++) {
			var c = string.charCodeAt(n);
			if (c < 128) {
				utftext += String.fromCharCode(c);
			} else if ((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			} else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}

		}
		return utftext;
	}

	// private method for UTF-8 decoding  
	_utf8_decode = function(utftext) {
		var string = "";
		var i = 0;
		var c = c1 = c2 = 0;
		while (i < utftext.length) {
			c = utftext.charCodeAt(i);
			if (c < 128) {
				string += String.fromCharCode(c);
				i++;
			} else if ((c > 191) && (c < 224)) {
				c2 = utftext.charCodeAt(i + 1);
				string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
				i += 2;
			} else {
				c2 = utftext.charCodeAt(i + 1);
				c3 = utftext.charCodeAt(i + 2);
				string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
				i += 3;
			}
		}
		return string;
	}
}


var searchbase = true;
var searchlatlng = false;

function changesearchtype(type) {
	if (type == 2) {
		searchlatlng = true;
		$('.search-boxs .dropdown-toggle').text('经纬');
		$('#suggestId').hide();
		$('#suggestVIP').hide();
		$('#suggestLatlng').show();
	} else if (type == 1) {
		searchbase = false;
		searchlatlng = false;
		$('.search-boxs .dropdown-toggle').text('国际');
		$('#suggestId').hide();
		$('#suggestVIP').show();
		$('#suggestLatlng').hide();
		// $('#handelsearch').show();
	} else {
		searchbase = true;
		searchlatlng = false;
		$('.search-boxs .dropdown-toggle').text('国内');
		$('#suggestId').show();
		$('#suggestVIP').hide();
		$('#suggestLatlng').hide();
		// $('#handelsearch').hide();
	}
}


var isDirectOpen = 0;
var lng = '';
var cityName = '';
$(function() {
	//实线虚线组件
	var mapitem = document.querySelectorAll('.mapitem');
	if (mapurl) {
		currentX = mapurl.split("#")[0];
		currentY = mapurl.split("#")[1];
		currentZ = parseInt(mapurl.split("#")[2]);
		coord = new maptalks.Coordinate(currentX, currentY);
		var b = new Base64();
		ms = b.encode(mapurl);
		for (var i = 0; i < mapitem.length; i++) {
			if (mt == mapitem[i].getAttribute('mapid') && mapitem[i].textContent.indexOf('谷歌卫星') != -1) {
				isgoogle = true;
			}
		}
		get_map(mt);
	};
	if (!areaId && !mapurl) {
		for (var i = 0; i < mapitem.length; i++) {
			if (mapitem[i].textContent.indexOf('谷歌卫星') != -1) {
				mt = mapitem[i].getAttribute('mapid');
				isgoogle = true;
			}
		}
	}

	if (window.location.href.indexOf('mt') != -1) {
		mt = window.location.href.split('mt=')[1].split('&')[0];
		ms = window.location.href.split('ms=')[1].split('&')[0];
		var b = new Base64();
		mapurl = b.decode(ms);
		currentX = mapurl.split("#")[0];
		currentY = mapurl.split("#")[1];
		currentZ = parseInt(mapurl.split("#")[2]);

		coord = new maptalks.Coordinate(currentX, currentY);
		var b = new Base64();
		ms = b.encode(mapurl);
		for (var i = 0; i < mapitem.length; i++) {
			if (mt == mapitem[i].getAttribute('mapid') && mapitem[i].textContent.indexOf('谷歌卫星') != -1) {
				isgoogle = true;
			}
		}
		get_map(mt);
	}

	if (window.location.href.indexOf('areaId') != -1) {
		areaId = window.location.href.split('areaId=')[1].split('&')[0];
		isDirectOpen = 1;
		$.ajax({
			type: "post",
			url: request + "/dituapi/tool/getarea",
			async: true,
			data: {
				areaId: areaId
			},
			success: function(data) {
				var res = JSON.parse(data);
				if (res.coordinates) {
					coordinates = JSON.parse(res.coordinates);
				} else {
					coordinates = [];
				}
				currentX = res.lng;
				cityName = res.name
				lng = currentX;
				currentY = res.lat;
				currentZ = res.zoom * 4 - 1;
				coord = new maptalks.Coordinate(currentX, currentY);
				var b = new Base64();
				mapurl = currentX + "#" + currentY + "#" + currentZ
				ms = b.encode(mapurl);
				get_map(currentMapId);
			}
		});
	}
	var isshowset = false;

	function setCookie(name, value) {
		window.localStorage.setItem(name, value);
		return;
	}

	$(function() {
		$('#showset').click(function() {

			if (usertype != "2" && usertype != "3") {
				layer.confirm('VIP专享功能，升级成为一起看地图VIP会员就可以使用啦！', {
						btn: ['马上升级', '我再看看'],
						//按钮，
						title: "温馨提示"
					},
					function() {
						window.location.href = "../user/pay/index.html";
					},
					function() {

					});
				return;
			};
			if (!isshowset) {
				isshowset = true;
				$('.setbox').hide();
				$('#map')[0].style.height = '100%';
				$('#zoomgroup').css('bottom', "25px");
				$('#showset')[0].className = "fa fa-compress ";

			} else {
				isshowset = false;
				$('.setbox').show();
				$('#map').css('height', 'calc(100% - 40px)')
				$('#zoomgroup').css('bottom', "110px");
				$('#showset')[0].className = "fa fa-arrows-alt";

			}
		});
		setTimeout(function() {

			if (!getCookie('isfirstTime')) {
				layer.tips('点击可进入全屏!', '#showset', {
					tips: [1, '#009efb'],
					time: 3000
				});
				setCookie('isfirstTime', 1);
				updateversion();
			} else {
				updateversion();
			}

			ac = new BMap.Autocomplete( //建立一个自动完成的对象
				{
					"input": "suggestId"
				});
			var myValue;
			ac.addEventListener("onconfirm",
				function(e) { //鼠标点击下拉列表后的事件

					if (usertype == "0") {
						layer.confirm('想要搜索地址请先登录,现在登录？', {
							btn: ['去登录', '算了'] //按钮
						}, function() {
							window.location.href = "../user/login.html";
						}, function() {

						});
						return;
					};

					var _value = e.item.value;
					myValue = _value.province + _value.city + _value.district + _value.street + _value.business;
					document.getElementById("suggestId").blur();

					var myGeo = new BMap.Geocoder();
					// 将地址解析结果显示在地图上,并调整地图视野
					myGeo.getPoint(myValue,
						function(point) {
							if (point) {
								if (getCookie("map") != "baidu") {
									point = Convert_BD09_To_GCJ02(point);
								};

								map.animateTo({
									center: [point.lng, point.lat],
									zoom: 13
								}, {
									duration: 1000
								});
								var searchResultTip = {
									'title': '',
									'content': myValue,
									'autoOpenOn': '',
									'width': 200
								};
								map.animateTo({
										zoom: 5
									}, {
										duration: 1000
									},
									function(frame) {
										if (frame.state.playState === 'finished') {
											map.animateTo({
													center: [point.lng, point.lat],
													zoom: 5
												}, {
													duration: 1000
												},
												function(frame) {
													if (frame.state.playState === 'finished') {
														map.animateTo({
																center: [point.lng, point.lat],
																zoom: 13
															}, {
																duration: 1000
															},
															function(frame) {
																if (frame.state.playState === 'finished') {
																	var infoWindow = new maptalks.ui.InfoWindow(searchResultTip);
																	var coord = new maptalks.Coordinate(point.lng, point.lat);
																	infoWindow.addTo(map).show(coord);
																}
															})
													};
												})
										};
									});
							} else {
								layer.msg('您选择地址没有解析到结果!');
							}
						},
						"");
				});
			document.getElementById('suggestId').addEventListener('keydown', function(e) {
				searchplace(e.code);
			})

			document.getElementById('headersearch').addEventListener('click', function(e) {
				if (searchlatlng) {
					var address = document.getElementById("suggestLatlng").value.replace(/ /g, "_");

					var reg = /\d+.\d*,\d+.\d*/g;

					if (address.match(reg) && address.match(reg).length == 1) {
						var lnglat = address.match(reg)[0].split(',');
						var latreg = /^(\-|\+)?([0-8]?\d{1}\.\d{0,6}|90\.0{0,6}|[0-8]?\d{1}|90)$/;
						var latitude = lnglat[1];
						if (!latreg.test(latitude)) {
							layer.msg('经纬度格式输入错误');
							return;
						}

						var longrg =
							/^(\-|\+)?(((\d|[1-9]\d|1[0-7]\d|0{1,3})\.\d{0,6})|(\d|[1-9]\d|1[0-7]\d|0{1,3})|180\.0{0,6}|180)$/;
						var longitude = lnglat[0];
						if (!longrg.test(longitude)) {
							layer.msg('经纬度格式输入错误');
							return;
						}
						map.setCenter([longitude, latitude]);
					} else {
						layer.msg('经纬度格式输入错误');
						return;
					}


					return;
				}
				searchplace('Enter');
			});
		}, 1000);
	})

	function searchplace(code) {

		if (code == "Enter" || code == "NumpadEnter") {
			if (!searchbase) {
				var address = document.getElementById("suggestVIP").value.replace(/ /g, "_");
				document.getElementById("suggestVIP").blur();
				if (address == "") {
					layer.tips('搜索词不能为空!', '#suggestVIP', {
						tips: [3, '#3595CC'],
						time: 2000
					});
					return;
				}

				if (usertype != "2" && usertype != "3") {
					layer.confirm('VIP专享功能，升级成为一起看地图VIP会员就可以使用啦！', {
							btn: ['马上升级', '我再看看'],
							//按钮，
							title: "温馨提示"
						},
						function() {
							window.location.href = "../user/pay/index.html";
						},
						function() {

						});
					return;
				}

				$.post(request + "/dituapi/index/place", {
						"name": address,
					},
					function(result) {
						result = JSON.parse(result);
						if (result.status == 1) {
							var searchResultTip = {
								'title': '',
								'content': result.fullname,
								'autoOpenOn': '',
								'width': 200
							};
							map.animateTo({
									zoom: 5
								}, {
									duration: 1000
								},
								function(frame) {
									if (frame.state.playState === 'finished') {
										map.animateTo({
												center: [result.lng, result.lat],
												zoom: 5
											}, {
												duration: 1000
											},
											function(frame) {
												if (frame.state.playState === 'finished') {
													map.animateTo({
															center: [result.lng, result.lat],
															zoom: 13
														}, {
															duration: 1000
														},
														function(frame) {
															if (frame.state.playState === 'finished') {
																var infoWindow = new maptalks.ui.InfoWindow(searchResultTip);
																var coord = new maptalks.Coordinate(result.lng, result.lat);
																infoWindow.addTo(map).show(coord);
															}
														});
												}
											});
									}
								});
						} else {
							layer.msg('搜索结果不存在！');
						}
					});
			} else {
				var address = document.getElementById("suggestId").value.replace(/ /g, "_");
				document.getElementById("suggestId").blur();
				if (address == "") {
					layer.tips('搜索词不能为空!', '#suggestId', {
						tips: [3, '#3595CC'],
						time: 2000
					});
					return;
				}
				document.getElementById("suggestId").blur();

				var myGeo = new BMap.Geocoder();
				// 将地址解析结果显示在地图上,并调整地图视野
				myGeo.getPoint(address,
					function(point) {
						if (point) {
							if (getCookie("map") != "baidu") {
								point = Convert_BD09_To_GCJ02(point);
							}

							map.animateTo({
								center: [point.lng, point.lat],
								zoom: 13
							}, {
								duration: 1000
							});
							var searchResultTip = {
								'title': '',
								'content': address,
								'autoOpenOn': '',
								'width': 200
							};
							map.animateTo({
									zoom: 5
								}, {
									duration: 1000
								},
								function(frame) {
									if (frame.state.playState === 'finished') {
										map.animateTo({
												center: [point.lng, point.lat],
												zoom: 5
											}, {
												duration: 1000
											},
											function(frame) {
												if (frame.state.playState === 'finished') {
													map.animateTo({
															center: [point.lng, point.lat],
															zoom: 13
														}, {
															duration: 1000
														},
														function(frame) {
															if (frame.state.playState === 'finished') {
																var infoWindow = new maptalks.ui.InfoWindow(searchResultTip);
																var coord = new maptalks.Coordinate(point.lng, point.lat);
																infoWindow.addTo(map).show(coord);
															}
														});
												}
											});
									}
								});
						} else {
							layer.msg('您选择地址没有解析到结果!');
						}
					}, "中国");
			}
		}
	}
	$(".dropdown-menu").on('click', function(e) {
		e.stopPropagation();
	});

	$("#displayjwd").on('click', function(e) {
		var show = $('#jwd').css('display');
		if (show == "block") {
			$('#jwd').css('display', "none");
		} else {
			$('#jwd').css('display', "block");
		}
	});

});

map.on('click', mapclick);
map.on('moveend zoomend', update);
map.on('moving moveend zoomend', updateMoving);
map.on('dragrotating', rotating);
update();
addTools();
addCross();
map.on('contextmenu',
	function(e) {
		rightClick(e.coordinate);
	});
var collectionid = 0;
if (window.location.href.indexOf('maprkid') != -1) {
	collectionid = window.location.href.split('maprkid=')[1].split('&')[0].split('#')[0];
}

if (window.location.href.indexOf('favorite') != -1) {
	var favarite = window.location.href.split('favorite=')[1].split('&')[0].split('#')[0];
	var b = new Base64();
	var favurl = b.decode(favarite);
	currentX = favurl.split("#")[0];
	currentY = favurl.split("#")[1];
	currentZ = parseInt(favurl.split("#")[2]);
	map.setCenter([currentX, currentY]);
}
var sharetitle;
if (collectionid) {
	//loading层
	var layerindex = layer.load(1, {
		shade: [1, '#fff'] //0.1透明度的白色背景
	});
	var timers = setTimeout(function() {
		$.ajax({
			type: "post",
			url: request + "/dituapi/tool/getcollection",
			async: true,
			data: {
				'id': collectionid,
				token: token
			},
			xhrFields: {
				withCredentials: true
			},
			crossDomain: true,
			success: function(result) {

				result = JSON.parse(result);
				clearTimeout(timers);
				layer.close(layerindex);
				if (!result) return
				sharetitle = result.title;
				get_map(result.mapid, result);
				initDrawCollection();
			}
		});
	}, 1000);
}
if (window.location.href.indexOf('appid') != -1) {
	var appmapid = window.location.href.split('appid=')[1].split('&')[0].split('#')[0];
	if (window.location.href.indexOf('locateurl') != -1) {
		var locateurl = window.location.href.split('locateurl=')[1].split('&')[0].split('#')[0];
		var b = new Base64();
		var favurl = b.decode(locateurl);
		currentX = favurl.split("#")[0];
		currentY = favurl.split("#")[1];
		currentZ = parseInt(favurl.split("#")[2]);
		if (appmapid == 2) {
			var point = {
				"lng": currentX,
				"lat": currentY
			};

			var newP = Convert_GCJ02_To_BD09(point);
			currentX = newP.lng;
			currentY = newP.lat;
		}
	}
	get_map(appmapid);
}

function setmapurl(addr) {
	var b = new Base64();
	ms = b.encode(addr);
	var mapitems = document.querySelectorAll('.mapitem');
	if (!mapitems) return
	for (var i = 0; i < mapitems.length; i++) {
		var hrefurl = mapitems[i].getAttribute('href');
		if (hrefurl.indexOf('&locateurl=') != -1) {
			hrefurl = hrefurl.split('&locateurl=')[0];
		}

		mapitems[i].setAttribute('href', hrefurl + "&locateurl=" + ms);
	}
}

//更新中心点坐标
function update() {
	var projection = map.getProjection();
	var center = map.getCenter(),
		prj = projection.project(center),
		containerPoint = map.coordinateToContainerPoint(center).round();
	
	
	var zoom = map.getZoom();
	zoom = Math.round(zoom)
	$('#zoomnum').text(zoom);
	
	currentX = center.x.toFixed(5);
	currentY = center.y.toFixed(5);
	currentZ = map.getZoom();
	if(!islng){
		var x = changeFromlnglat(currentX,true);
		$("#centerX").text(x);
		var y = changeFromlnglat(currentY,false);
		$("#centerY").text(y);
	}else{
		document.getElementById('centerX').textContent = center.x.toFixed(5);
		document.getElementById('centerY').textContent = center.y.toFixed(5);
	}
	
	if (usertype == "0") {
		if (currentZ > 14) {
			map.setZoom(14);
			layer.confirm('想要浏览更高清的地图,现在登录？', {
				btn: ['去登录', '算了'] //按钮
			}, function() {
				window.location.href = "../user/login.html";
			}, function() {
			
			});
			return;
		}
	};
	
	if (isgoogle) {
		// VIPcount = 1;
	}
	
	if (usertype == "1") {

		if (currentZ > 16 && !checkvip(VIPcount)) {
			map.setZoom(16);

			layer.confirm('成为一起看地图VIP会员，轻松浏览高清的卫星地图，还可以获得以下功能:<font color="blue">' +
				'<br>1.搜索国内外地址。<br>2.高清卫星地图免费浏览。<br>3.海拔免费查询。<br>4.面积测量功能。<br>5.三倍签到积分。<br>6.地图无限制收藏。<br>7.本站所有地图工具免费使用。<br>8.更多功能，期待您的发现...</font>', {
					btn: ['去升级', '算了'], //按钮，
					title: "升级VIP会员提示"
				},
				function() {
					window.location.href = "../user/pay/index.html";
				},
				function() {

				});
			return;
		}
	};

	var addr = currentX + "#" + currentY + "#" + currentZ;
	if (ms != "" || areaId != "" || mt != 1) {
		var b = new Base64();
		ms = b.encode(addr);
		var url = "";

		if (areaId != "") {
			url = "/map/" + areaId + ".html?mt=" + mt + "&ms=" + ms;
		} else {
			url = "?mt=" + mt + "&ms=" + ms;
		};
		setStates("", url);
	} else {
		var b = new Base64();
		ms = b.encode(addr);
		setStates("", "/");
	}
	if (posMarker && posMarker.isVisible()) {
		posMarker.setCoordinates(map.getCenter());
		posMarker.updateSymbol({
			'markerRotation': map.getBearing()
		});
	}
	if (luopanMarker && luopanMarker.isVisible()) {
		luopanMarker.setCoordinates(map.getCenter());
		luopanCrossMarker.setCoordinates(map.getCenter());
		luopanMarker.updateSymbol({
			'markerRotation': -currentDec() + map.getBearing()
		});
		$("#mageLat").text(currentX);
		$("#mageLng").text(currentY);
		$("#magedir").text(currentDec());
	}
};

//放大镜
function mousemovefdj(e) {
	mousePosition = e.containerPoint;
	map.getRenderer().setToRedraw();
};

function mouseoutfdj(e) {
	mousePosition = null;
	map.getRenderer().setToRedraw();
};

function renderfdj(e) {
	if (!mousePosition) {
		return;
	}
	var ctx = e.context;
	var radius = 150;
	var pixelRatio = (window.devicePixelRatio || (window.screen.deviceXDPI / window.screen.logicalXDPI));
	radius *= (pixelRatio > 1 ? 2 : 1);
	var centerX = mousePosition.x * pixelRatio,
		centerY = mousePosition.y * pixelRatio;
	var originX = centerX - radius,
		originY = centerY - radius;
	var size = 2 * radius + 2;
	var sourceData = ctx.getImageData(originX, originY, size, size).data;
	var dest = ctx.createImageData(size, size);
	var destData = dest.data;
	for (var j = 0; j < size; ++j) {
		for (var i = 0; i < size; ++i) {
			var dI = i - radius;
			var dJ = j - radius;
			var dist = Math.sqrt(dI * dI + dJ * dJ);
			var sourceI = i;
			var sourceJ = j;
			if (dist < radius) {
				sourceI = Math.round(radius + dI / 2);
				sourceJ = Math.round(radius + dJ / 2);
			}
			var destOffset = (j * size + i) * 4;
			var sourceOffset = (sourceJ * size + sourceI) * 4;
			destData[destOffset] = sourceData[sourceOffset];
			destData[destOffset + 1] = sourceData[sourceOffset + 1];
			destData[destOffset + 2] = sourceData[sourceOffset + 2];
			destData[destOffset + 3] = sourceData[sourceOffset + 3];
		}
	}
	// draw magnifier's outline
	ctx.beginPath();
	ctx.strokeStyle = '#bbb';
	ctx.lineWidth = 2;
	ctx.arc(centerX, centerY, radius + 2, 0, 2 * Math.PI);
	ctx.stroke();
	ctx.closePath();

	// draw magnified image and clip it by circle
	ctx.drawImage(createMagCircle(dest, size), centerX - size / 2, centerY - size / 2);
};

function createMagCircle(imageData, size) {
	var magImg = document.createElement('canvas');
	var magCircle = document.createElement('canvas');

	magImg.width = magImg.height = magCircle.width = magCircle.height = size;
	magImg.getContext('2d').putImageData(imageData, 0, 0);

	var ctx = magCircle.getContext('2d');
	ctx.beginPath();
	ctx.arc(size / 2, size / 2, size / 2, 0, 2 * Math.PI);
	// clip canvas
	ctx.clip();
	ctx.drawImage(magImg, 0, 0);
	return magCircle;
};
var mousePosition = null;

function openfdj() {
	mousePosition = null;

	map.on('mousemove', mousemovefdj);

	map.on('mouseout', mouseoutfdj);

	map.on('renderend', renderfdj)
};

function closefdj() {
	map.off('mousemove', mousemovefdj);

	map.off('mouseout', mouseoutfdj);

	map.off('renderend', renderfdj)
};
var isfdj = false;

var ishaiba = false;

function hidehaiba() {
	//重置海拔按钮
	$('#haiba')[0].className = 'btn';
	$('#haiba')[0].setAttribute('aria-pressed', false);
}
//测量海拔
document.getElementById("haiba").onclick = function() {
	closefdj();
	if (ishaiba) {
		ishaiba = false;
		layer.msg('查看海拔已关闭！');
	} else {

		if (usertype == "0") {

			layer.confirm('查看海拔需要登录,现在登录？', {
				btn: ['去登录', '算了'] //按钮
			}, function() {
				window.location.href = "../user/login.html";
			}, function() {
				hidehaiba();
			});
			return;
		};
		
		if (usertype != 0 && usertype == 1) {
			layer.confirm(
				'由于谷歌接口的限制，海拔查询每日额度有限，为了保证需要的用户的资源充足，现在每查询一次海拔需要扣除<font color="red">1个图币</font>，请保证您的账户中图币充足，图币可以通过签到等任务获取。<br>您的图币数量: <font color="blue">' +
				userscore + "个</font><br><font color='red'>VIP会员免费查询</font>", {
					btn: ['继续查看', '算了'] //按钮
				},
				function() {
					ishaiba = true;
					layer.msg('点击地图任何点就可以显示该地方的海拔了!');
				},
				function() {
					hidehaiba();
					return;
			});
			return;
		}
		ishaiba = true;
		layer.msg('点击地图任何点就可以显示该地方的海拔了!');

	}
};
//海拔
function mapclick(event) {
	initbuttom();
	if (ishaiba) {
		var lng = event.coordinate.x;
		var lat = event.coordinate.y;
		$.ajax({
			type: "post",
			url: request + "/dituapi/index/elevation",
			async: true,
			xhrFields: {
				withCredentials: true
			},
			crossDomain: true,
			data: {
				"latlng": lat + "," + lng,
				token: token
			},
			success: function(result) {

				result = JSON.parse(result);

				if (result.status == 1) {
					var positionTips = {
						'title': '当前位置',
						'content': '坐标：' + lng.toFixed(5) + "," + lat.toFixed(5) + "<br>" + '海拔：' + Math.round(10 * result.altitude) /
							10 + "米",
						'autoOpenOn': '',
						'width': 200
					};
					coord = new maptalks.Coordinate(lng, lat);
					var infoWindow = new maptalks.ui.InfoWindow(positionTips);
					infoWindow.addTo(map).show(coord);
					if (usertype <= 1) {
						userscore = userscore - 1;
						var userdata = JSON.parse(getCookie('user'));
						userdata.user.score = userscore;
						setCookie('user', JSON.stringify(userdata));
					}
				} else if (result.status == 2) {
					layer.confirm('查看海拔需要登录,现在登录？', {
						btn: ['去登录', '算了'] //按钮
					}, function() {
						window.location.href = "../user/login.html";
					}, function() {});
				} else if (result.status == 3) {
					layer.msg('图币不足!', {
						icon: 0
					});
				} else {
					layer.msg('您选择地址没有得到海拔数据!');
				}
			}
		});

	};
};

//定位
var locationMarker;
var islocate = false;
var locationLayer;
document.getElementById("locationbtn").onclick = function() {
	if (!islocate) {
		islocate = true;
		closefdj();
		locateMsg = layer.msg('正在定位中...', {
			time: 10000
		});

		var geolocation = new BMap.Geolocation();
		geolocation.getCurrentPosition(function(r) {
			if (this.getStatus() == BMAP_STATUS_SUCCESS) {
				var mk = new BMap.Marker(r.point);
				var posi = {
					coords: {
						longitude: r.point.lng,
						latitude: r.point.lat
					}
				}
				locatesucc(posi)
			} else {
				layer.msg('当前设备不支持定位功能!');
				islocate = false;
			}
		}, {
			enableHighAccuracy: true
		})
	} else {
		navigator.geolocation.clearWatch(watchId);
		islocate = false;
		if (!isFangwei) {
			canvasLayer.show();
			plusshow = true;
		}
		$('#redcross').prop("checked", true);
		locationMarker.remove();
		locationLayer.remove();
	}

};

function locationSuccess(position) {

	var coords = position.coords;
	var bdPoint = new BMap.Point(coords.longitude, coords.latitude);

	var convertor = new BMap.Convertor();
	var pointArr = [];
	pointArr.push(bdPoint);
	convertor.translate(pointArr, 1, 5, translateCallback);
	canvasLayer.hide();

	$('#location').removeClass('active');
	plusshow = false;
	if (locateMsg) {
		layer.close(locateMsg);
	};

	function translateCallback(data) {
		layer.msg('定位成功');
		bdPoint = data.points[0];
		var address = "";
		if (locationLayer) {
			locationLayer.remove();
		};

		locationLayer = new maptalks.VectorLayer('我的定位').addTo(map);

		var px;
		var py;
		if (getCookie("map") == "baidu") {
			px = bdPoint.lng;
			py = bdPoint.lat;
		};

		if (getCookie("map") != "baidu") {
			var currentPoint = Convert_BD09_To_GCJ02(bdPoint);
			px = currentPoint.lng;
			py = currentPoint.lat;
		};

		locationMarker = new maptalks.Marker([px, py], {
			'symbol': {
				'markerType': 'ellipse',
				'markerFill': '#0f89f5',
				'markerFillOpacity': 1,
				'markerLineColor': '#fff',
				'markerLineWidth': 2,
				'markerLineOpacity': 1,
				'markerLineDasharray': [],
				'markerWidth': 12,
				'markerHeight': 12,
				'markerDx': 0,
				'markerDy': 0,
				'markerOpacity': 1
			}
		});

		locationMarker.addTo(locationLayer);
		currentX = px;
		currentY = py;
		map.setCenter([px, py]);
		map.setZoom(16);
		var geooptions = {
			// 指示浏览器获取高精度的位置，默认为false  
			enableHighAcuracy: true,
			// 最长有效期，在重复获取地理位置时，此参数指定多久再次获取位置。  
			maximumAge: 1000
		};
		watchId = navigator.geolocation.watchPosition(watchLocationSuccess, locationWatchError, geooptions);
		if (!islocate) {
			islocate = true;
			canvasLayer.hide();
			$('#point_control').removeClass('active');
			plusshow = false;
			if (locateMsg) {
				layer.close(locateMsg);
			};
			layer.tips('定位成功!再次点击关闭定位。', '#locatebtn', {
				tips: [1, '#006400'],
				time: 2000
			});
		};
	};
};

function locatesucc(position) {
	var coords = position.coords;

	px = coords.longitude;
	py = coords.latitude;
	if (getCookie("map") != "baidu") {
		var bdPoint = new BMap.Point(coords.longitude, coords.latitude);
		var currentPoint = Convert_BD09_To_GCJ02(bdPoint);
		px = currentPoint.lng;
		py = currentPoint.lat;
	};
	canvasLayer.hide();
	$('#redcross').removeAttr('checked');
	$('#location').removeClass('active');
	plusshow = false;
	if (locateMsg) {
		layer.close(locateMsg);
	};

	layer.msg('定位成功');
	if (locationLayer) {
		locationLayer.remove();
	};
	locationLayer = new maptalks.VectorLayer('我的定位').addTo(map);
	if (window.DeviceOrientationEvent) {
		locationMarker = new maptalks.Marker([px, py], {
			'symbol': {
				'markerFile': "../static/images/directe.png?20191105",
				'markerWidth': 20,
				'markerHeight': 20,
				'markerDx': 0,
				'markerDy': 10,
				'markerOpacity': 1,
				'markerRotation': 0
			}
		});

		var ua = navigator.userAgent.toLowerCase();
		if (/android/.test(ua)) {
			window.addEventListener('deviceorientationabsolute', DeviceOrientationHandler, false);

			function DeviceOrientationHandler(event) {
				var cor = event.alpha - 180;
				if (locationMarker) {
					locationMarker.updateSymbol({
						'markerRotation': cor + map.getBearing()
					});
				}
			}
		} else {
			window.addEventListener('deviceorientation', DeviceOrientationHandler, false);

			function DeviceOrientationHandler(event) {
				var cor = event.webkitCompassHeading - 180;
				if (locationMarker) {
					locationMarker.updateSymbol({
						'markerRotation': cor + map.getBearing()
					});
				}
			}
		}

	} else {

		locationMarker = new maptalks.Marker([px, py], {
			'symbol': {
				'markerType': 'ellipse',
				'markerFill': '#0f89f5',
				'markerFillOpacity': 1,
				'markerLineColor': '#fff',
				'markerLineWidth': 2,
				'markerLineOpacity': 1,
				'markerLineDasharray': [],
				'markerWidth': 12,
				'markerHeight': 12,
				'markerDx': 0,
				'markerDy': 0,
				'markerOpacity': 1
			}
		});
	}
	locationMarker.addTo(locationLayer);
	currentX = px;
	currentY = py;
	map.setCenter([px, py]);
	map.setZoom(15);
	var geooptions = {
		// 指示浏览器获取高精度的位置，默认为false  
		enableHighAcuracy: true,
		// 最长有效期，在重复获取地理位置时，此参数指定多久再次获取位置。  
		maximumAge: 1000
	};
	watchId = navigator.geolocation.watchPosition(watchLocationSuccess, locationWatchError, geooptions);
	if (!islocate) {
		islocate = true;
		canvasLayer.hide();
		$('#point_control').removeClass('active');
		$('#redcross').removeAttr('checked');
		plusshow = false;
		if (locateMsg) {
			layer.close(locateMsg);
		}
		layer.tips('定位成功!再次点击关闭定位。', '#locatebtn', {
			tips: [1, '#006400'],
			time: 2000
		});
	}
}

function getLocation() {

	if (navigator.geolocation) {
		navigator.geolocation.getCurrentPosition(locationSuccess, showError);
	} else {
		canvasLayer.hide();
		$('#point_control').removeClass('active');
		$('#location').removeClass('active');
		plusshow = false;
		if (locateMsg) {
			layer.close(locateMsg);
		};
		layer.msg('当前设备不支持定位功能!');
	}
}

function showError(error) {
	canvasLayer.hide();
	$('#point_control').removeClass('active');
	$('#location').removeClass('active');
	plusshow = false;
	if (locateMsg) {
		layer.close(locateMsg);
	};

	switch (error.code) {
		case error.PERMISSION_DENIED:
			layer.msg("用户拒绝对获取地理位置的请求");
			break;
		case error.POSITION_UNAVAILABLE:
			layer.msg("位置信息是不可用的");
			break;
		case error.TIMEOUT:
			layer.msg("请求用户地理位置超时");
			break;
		case error.UNKNOWN_ERROR:
			layer.msg("未知错误");
			break;
	}
}

function locationError(error) {
	islocate = false;
	switch (error.code) {
		case error.TIMEOUT:
			layer.msg('GPS定位超时，已切换到IP定位!');
			switchlocate();
			break;
		case error.POSITION_UNAVAILABLE:
			layer.msg('GPS位置无法获取，已切换到IP定位!');
			switchlocate();
			break;
		case error.PERMISSION_DENIED:
			layer.msg('GPS功能无法使用，已切换到IP定位!');
			switchlocate();
			break;
		case error.UNKNOWN_ERROR:
			layer.msg('GPS未知错误，已切换到IP定位!');
			switchlocate();
			break;
	};
};

//获取经纬度地点
$('#goxy').on("click", function() {
	goxy();
});

function goxy() {
	var currentXValue = document.getElementById("centerX").textContent;
	var currentYValue = document.getElementById("centerY").textContent;
	map.animateTo({
		center: [currentXValue, currentYValue],
		zoom: 15
	}, {
		duration: 2000
	});
};

// 定位当前城市
getcurrentcity();

function getcurrentcity() {
	var geolocation = new BMap.Geolocation();
	geolocation.getCurrentPosition(function(r) {

		var addr = r.longitude + "#" + r.latitude + "#" + 10;
		var b = new Base64();
		ms = b.encode(addr);
		$('#currentcity').attr('href', '#');
		$('#currentcity').html(r.address.city);

		if (!collectionid && !mt) {
			currentX = r.longitude;
			currentY = r.latitude;
			currentZ = 13;
			map.setCenter([currentX, currentY]);
			map.setZoom(13);
		}

		$('#currentcity').click(function() {
			$('.areaselect').removeClass('show');
			currentX = r.longitude;
			currentY = r.latitude;
			if (currentZ < 10) {
				currentZ = 10;
			}
			map.animateTo({
				center: [currentX, currentY],
				zoom: currentZ
			}, {
				duration: 2000
			});
		});
		return;
	})
};
var istrail = false;


function getLocalTime(nS) {
	return new Date(parseInt(nS) * 1000).toLocaleString().replace(/:\d{1,2}$/, ' ');
}

//根据ip定位，并移动到当前城市
function switchlocate() {
	var geolocation = new BMap.Geolocation();
	geolocation.getCurrentPosition(function(r) {
		bdPoint = r.point;
		var address = "";
		if (locationLayer) {
			locationLayer.remove();
		};

		locationLayer = new maptalks.VectorLayer('我的定位').addTo(map);

		var px;
		var py;
		if (getCookie("map") == "baidu") {
			px = bdPoint.lng;
			py = bdPoint.lat;
		};

		if (getCookie("map") != "baidu") {
			var currentPoint = Convert_BD09_To_GCJ02(bdPoint);
			px = currentPoint.lng;
			py = currentPoint.lat;
		};

		locationMarker = new maptalks.Marker([px, py], {
			'symbol': {
				'markerType': 'ellipse',
				'markerFill': '#0f89f5',
				'markerFillOpacity': 1,
				'markerLineColor': '#fff',
				'markerLineWidth': 2,
				'markerLineOpacity': 1,
				'markerLineDasharray': [],
				'markerWidth': 12,
				'markerHeight': 12,
				'markerDx': 0,
				'markerDy': 0,
				'markerOpacity': 1
			}
		});

		locationMarker.addTo(locationLayer);
		currentX = px;
		currentY = py;
		map.setCenter([px, py]);
		map.setZoom(16);
		var geooptions = {
			// 指示浏览器获取高精度的位置，默认为false  
			enableHighAcuracy: true,
			// 最长有效期，在重复获取地理位置时，此参数指定多久再次获取位置。  
			maximumAge: 1000
		};
		watchId = navigator.geolocation.watchPosition(watchLocationSuccess, locationWatchError, geooptions);
		if (!islocate) {
			islocate = true;
			canvasLayer.hide();
			$('#point_control').removeClass('active');
			plusshow = false;
			if (locateMsg) {
				layer.close(locateMsg);
			};
			layer.tips('定位成功!再次点击关闭定位。', '#locatebtn', {
				tips: [1, '#006400'],
				time: 2000
			});
		};
	});
};

function watchLocationSuccess(position) {
	var coords = position.coords;
	var bdPoint = new BMap.Point(coords.longitude, coords.latitude);

	var convertor = new BMap.Convertor();
	var pointArr = [];
	pointArr.push(bdPoint);
	convertor.translate(pointArr, 1, 5, translateCallback2);

	function translateCallback2(data) {
		bdPoint = data.points[0];
		var address = "";

		var px;
		var py;
		if (getCookie("map") == "baidu") {
			px = bdPoint.lng;
			py = bdPoint.lat;
		};

		if (getCookie("map") != "baidu") {
			var currentPoint = Convert_BD09_To_GCJ02(bdPoint);
			px = currentPoint.lng;
			py = currentPoint.lat;
		};

		locationMarker.setCoordinates([px, py]);
	};
};

function locationWatchError(error) {
	//islocate = false;
};

//测距
function distanceClick() {
	ishaiba = false;
	hidehaiba();
	startDistance();
}


function startDistance() {
	distanceTool.addTo(map);
	layer.msg('点击地图开始测量，双击结束测量!');
	freedraw = false;
	if (freeBox) {
		freeBox.hide();
	}
	hide_lineBox();
	hide_pointBox();
	hide_areaBox();
};
var freedraw = false;
//点击标点
function mark_point() {
	if (hidedraw) {
		layer.msg('当前为他人标注，不可编辑');
		return;
	}
	$('#label').show();
	freedraw = false;
	if (freeBox) {
		freeBox.hide();
	}
	pointTool.setMode('Point').enable();
	pointTool.setSymbol({
		'markerFile': "https://cdn.17ditu.com/static/app/images/draw_location.png",
		'markerWidth': 30,
	});
	layer.msg('单击即可标点！');
	hidehaiba();
	hide_lineBox();
	hide_pointBox();
	hide_areaBox();
	selected = false;
}

//点击标线
function mark_line() {
	if (hidedraw) {
		layer.msg('当前为他人标注，不可编辑');
		return;
	}
	$('#label').show();
	freedraw = false;
	if (freeBox) {
		freeBox.hide();
	}
	pointTool.setMode('LineString').enable();
	pointTool.setSymbol({
		'lineColor': '#ff5366',
		'lineWidth': '4'
	});
	layer.msg('单击地图开始，双击结束！');
	hidehaiba();
	hide_lineBox();
	hide_pointBox();
	hide_areaBox();
	selected = false;

}


//点击标面
function mark_polygon() {
	if (hidedraw) {
		layer.msg('当前为他人标注，不可编辑');
		return;
	}
	$('#label').show();

	freedraw = false;
	if (freeBox) {
		freeBox.hide();
	}

	pointTool.setMode('Polygon').enable();
	pointTool.setSymbol({
		'lineColor': '#ff5366',
		'polygonFill': '#ffffff',
		"polygonOpacity": "0.4",
		'lineWidth': '4'
	});
	layer.msg('单击地图开始，双击结束！');
	hidehaiba();
	hide_lineBox();
	hide_pointBox();
	hide_areaBox();
	selected = false;
}

//点击自由画
$('#freedraw').click(function() {
	if (hidedraw) {
		layer.msg('当前为他人标注，不可编辑');
		return;
	}
	freedraw = true;
	pointTool.setMode('FreeHandLineString').enable();
	pointTool.setSymbol({
		'lineColor': '#ff5366'
	});
	layer.msg('按住鼠标绘画开始，放开结束！');
	hidehaiba();
	hide_lineBox();
	hide_pointBox();
	hide_areaBox();
});

function clear_map() {
	if (distanceTool) {
		distanceTool.endDraw();
		distanceTool.clear();
	};

	if (areaTool) {
		areaTool.endDraw();
		areaTool.clear();

	};
	if (map.getLayer('vector')) {
		map.getLayer('vector').clear();
	}
	hide_lineBox();
	hide_pointBox();
	hide_areaBox();

	mapTool.clear();
	if (point_tips) {
		point_tips.hide();
	}
	if (line_tips) {
		line_tips.hide();
	}
	if (area_tips) {
		area_tips.hide();
	}
	if (placeMarker) {
		placeMarker.hide();
	}
	if (freeBox) {
		freeBox.hide();
	}

}
//清除
$('#clear').click(function() {
	if (issetshow) {
		issetshow = false;
		$('.dituset').hide();
	}
	if (map.getLayer('vector')) {
		map.getLayer('vector').clear();
	}
	if (map.getLayer('vector1')) {
		map.getLayer('vector1').clear();
	}

	clear_map();
	layer.msg('清除成功！');
});

//清除
function mark_clear() {
	selected = false;
	clear_map();
	layer.msg('清除成功！');
}

function initDrawCollection() {
	$('#functionbtn').popover('hide');
	$('.setbox').hide();
	$('#map')[0].style.height = '100%';
	$('#showset').hide();
	$("#controlbar").hide();
	$("#hidebtn").hide();
	$("#locationbtn").hide();
	$("#zoomgroup").hide();
	$("#areachioce").hide();
	$(".header").hide();
	$(".drawbox").show();
	if (hidedraw) {
		$('#label_editor').show();
	} else {
		$('#label').show();
	}
};
//测量面积
function areaClick() {
	if (usertype != "2" && usertype != "3") {
		layer.confirm('VIP专享功能，升级成为一起看地图VIP会员就可以使用啦！', {
				btn: ['马上升级', '算了'],
				//按钮，
				title: "温馨提示"
			},
			function() {
				window.location.href = "../user/pay/index.html";
			},
			function() {

			});
		return;
	}

	ishaiba = false;
	hidehaiba();
	startArea();

}
//点击测量工具
function initmaptool() {
	$('#functionbtn').popover('hide');
	$('.setbox').hide();
	$('#map')[0].style.height = '100%';
	$('#showset').hide();
	$("#controlbar").hide();
	$("#hidebtn").hide();
	$("#locationbtn").hide();
	$("#zoomgroup").hide();
	$("#areachioce").hide();
	$(".header").hide();
	$(".toolbox").show();
}
//关闭测量
function tool_close() {
	var layerbox = layer.confirm('关闭将清除所有测量数据，确认继续吗？', {
			btn: ['继续', '算了'] //按钮
		},
		function() {
			layer.close(layerbox);
			$('.setbox').show();
			$('#map')[0].style.height = 'calc(100% - 40px)';
			$('#showset').show();
			$("#controlbar").show();
			$("#hidebtn").show();
			$("#locationbtn").show();
			$("#zoomgroup").show();
			$("#areachioce").show();
			$(".header").show();
			$(".toolbox").hide();
		},
		function() {

		});
	return false;

}

function mark_close() {
	var layerbox = layer.confirm('请先保存标注，否则将清除当前标注，确认继续吗？', {
			btn: ['继续', '算了'] //按钮
		},
		function() {
			layer.close(layerbox);
			selected = false;
			clear_map();
			collectionid = 0;
			drawtitle = "";
			$('.setbox').show();
			$('#map')[0].style.height = 'calc(100% - 40px)';
			$('#showset').show();
			$("#controlbar").show();
			$("#hidebtn").show();
			$("#locationbtn").show();
			$("#zoomgroup").show();
			$("#areachioce").show();
			$(".header").show();
			$(".drawbox").hide();
			$('#label_editor').hide();
			$('#label').hide();
		},
		function() {

		});
	return false;
}

//隐藏标点图片
function hide_pointBox() {
	if (point_box) {
		box_show = false;
		point_box.hide();
	}
}

//隐藏标线编辑框
function hide_lineBox() {
	if (line_box) {
		box_show = false;
		line_box.hide();
	}
}

//隐藏标面编辑框
function hide_areaBox() {
	if (area_box) {
		box_show = false;
		area_box.hide();
	}
}

function startArea() {
	areaTool.addTo(map);
	layer.msg('点击地图开始测量，双击结束测量!');
};

$('.share').click(function() {
	if (issetshow) {
		issetshow = false;
		$('.dituset').hide();
	}
	share();
});

var layerIndex2;

function share() {
	if (issetshow) {
		issetshow = false;
		$('.dituset').hide();
	}
	var url = "https://a.app.qq.com/o/simple.jsp?pkgname=com.yiqiditu.app";

	url = getshorturl(url);
	plus.share.sendWithSystem({
		content: '一起看地图APP下载',
		href: url
	}, function() {

	}, function(e) {

	});
	return;
};

function sharelocation() {
	if (issetshow) {
		issetshow = false;
		$('.dituset').hide();
	}

	var geolocation = new BMap.Geolocation();
	geolocation.getCurrentPosition(function(r) {
		if (this.getStatus() == BMAP_STATUS_SUCCESS) {
			var mk = new BMap.Marker(r.point);
			var posi = {
				coords: {
					longitude: r.point.lng,
					latitude: r.point.lat
				}
			}
			var coords = posi.coords;

			var px = coords.longitude;
			var py = coords.latitude;
			if (getCookie("map") != "baidu") {
				var bdPoint = new BMap.Point(coords.longitude, coords.latitude);
				var currentPoint = Convert_BD09_To_GCJ02(bdPoint);
				px = currentPoint.lng;
				py = currentPoint.lat;
			};
			var b = new Base64();
			var sharemapurl = px + "#" + py + "#" + 16;
			var sharems = b.encode(sharemapurl);
			var url = 'https://17ditu.com?mt=' + currentMapId + "&ms=" + sharems + "&l=1";
			url = getshorturl(url);


			plus.share.sendWithSystem({
				content: '一起看地图，查看我分享的位置',
				href: url
			}, function() {

			}, function(e) {

			});
		} else {
			layer.msg('发送失败');
		}
	}, {
		enableHighAccuracy: true
	})
}

function copyurl(event) {
	const range = document.createRange();
	range.selectNode(document.getElementById('shareurl'));

	const selection = window.getSelection();
	if (selection.rangeCount > 0) selection.removeAllRanges();
	selection.addRange(range);
	document.execCommand('copy');
	layer.tips('复制成功！', '#copyurlbtn', {
		tips: [1, '#006400'],
		time: 2000
	});
};

var ponitsymbol = null;
var freeBox = null;
//添加工具方法
function addTools() {
	//绘制工具（标点，标线，标面）
	if (mapTool) {
		mapTool.remove();
	}
	mapTool = new maptalks.VectorLayer('vector').addTo(map);
	pointTool = new maptalks.DrawTool({
		mode: 'Point',
		'once': true,
		draggable: false,
	}).addTo(map).disable();
	ponitsymbol = pointTool.getSymbol();
	pointTool.on('drawend', function(param) {
		addcollection(param);

	});

	distanceTool = new maptalks.DistanceTool({
		'once': true,
		'symbol': {
			'lineColor': '#ff0',
			'lineWidth': 3
		},
		'vertexSymbol': {
			'markerType': 'ellipse',
			'markerFill': '#fff',
			'markerLineColor': '#f00',
			'markerLineWidth': 2,
			'markerWidth': 6,
			'markerHeight': 6
		},
		'labelOptions': {
			'textSymbol': {
				'textFaceName': 'monospace',
				'textFill': '#000',
				'textLineSpacing': 1,
				'textHorizontalAlignment': 'right',
				'textDx': 15,
				'markerLineColor': '#DDDD22',
				'markerFill': '#DDDD22'
			},
			'boxStyle': {
				'padding': [6, 2],
				'symbol': {
					'markerType': 'square',
					'markerFill': '#fff',
					'markerFillOpacity': 0.9,
					'markerLineColor': '#b4b3b3'
				}
			}
		},
		'clearButtonSymbol': [{
				'markerType': 'square',
				'markerFill': '#fff',
				'markerLineColor': '#b4b3b3',
				'markerLineWidth': 2,
				'markerWidth': 15,
				'markerHeight': 15,
				'markerDx': 22
			},
			{
				'markerType': 'x',
				'markerWidth': 10,
				'markerHeight': 10,
				'markerLineColor': '#000',
				'markerDx': 22
			}
		],
		'language': 'zh-CN'
	});

	//测量面积工具
	areaTool = new maptalks.AreaTool({
		'imperial': false,
		'metric': true,
		'once': true,
		'symbol': {
			'lineColor': '#f00',
			'lineWidth': 2,
			'polygonFill': '#fff',
			'polygonOpacity': 0.4
		},
		'vertexSymbol': {
			'markerType': 'ellipse',
			'markerFill': '#fff',
			'markerLineColor': '#666',
			'markerLineWidth': 2,
			'markerWidth': 6,
			'markerHeight': 6
		},
		'labelOptions': {
			'textSymbol': {
				'textFaceName': 'monospace',
				'textFill': '#000',
				'textLineSpacing': 1,
				'textHorizontalAlignment': 'right',
				'textDx': 15
			},
			'boxStyle': {
				'padding': [6, 2],
				'symbol': {
					'markerType': 'square',
					'markerFill': '#fff',
					'markerFillOpacity': 0.9,
					'markerLineColor': '#b4b3b3'
				}
			}
		},
		'clearButtonSymbol': [{
				'markerType': 'square',
				'markerFill': '#fff',
				'markerLineColor': '#b4b3b3',
				'markerLineWidth': 2,
				'markerWidth': 15,
				'markerHeight': 15,
				'markerDx': 22
			},
			{
				'markerType': 'x',
				'markerWidth': 10,
				'markerHeight': 10,
				'markerLineColor': '#000',
				'markerDx': 22
			}
		],
		language: 'zh-CN'
	});

};

window.get_drawcollection = function() {
	return;
	$.ajax({
		type: "post",
		url: request + "/dituapi/tool/get_drawcollection",
		async: true,
		data: {
			token: token
		},
		xhrFields: {
			withCredentials: true
		},
		crossDomain: true,
		success: function(data) {
			var data = JSON.parse(data);
			var html = "";
			for (var i = 0; i < data.length; i++) {
				html += '<li><a class="collectionitem" href="#"  mapid="' + data[i].id + '">' + data[i].title + '</a></li>'
			}

			$('.traildetial ul').html(html);
			$('.collectionitem').click(function() {
				var mapid = this.getAttribute('mapid');
				$.ajax({
					type: "post",
					url: request + "/dituapi/tool/getcollection",
					async: true,
					data: {
						'id': mapid,
						token: token
					},
					xhrFields: {
						withCredentials: true
					},
					crossDomain: true,
					success: function(result) {
						closeleft();
						result = JSON.parse(result);
						get_map(result.mapid, result);
					}
				});
			});
		}
	})
}

function set_darw_collectiom(result) {
	$('#label').show();
	collectionid = result.id;
	var des_arr = JSON.parse(result.des_arr.replace(/&quot;/g, '"'));
	var title_arr = JSON.parse(result.title_arr.replace(/&quot;/g, '"'));

	var mapdata = map.toJSON();
	var layer1 = map.getBaseLayer();
	var arr = mapdata.layers;
	for (var i = 0; i < arr.length; i++) {
		if (arr[i].id == "vector") {
			arr[i].geometries = [];
			var jsonarr = JSON.parse(result.json);
			for (var x = 0; x < jsonarr.length; x++) {
				arr[i].geometries.push(JSON.parse(jsonarr[x]));
			}
			break;
		} else if (i == arr.length - 1) {
			var item = {
				geometries: JSON.parse(result.json),
				id: 'vector',
				options: {},
				type: "VectorLayer"
			}
			arr.push(item);
		}
	}

	map.remove();
	mapdata.layers = arr;
	map = new maptalks.Map.fromJSON('map', mapdata);

	map.setBaseLayer(layer1)

	map.on('click', mapclick);
	map.on('moveend zoomend', update);
	map.on('moving moveend zoomend', updateMoving);
	map.on('dragrotating', rotating);
	update();
	addCross();
	map.on('contextmenu',
		function(e) {
			rightClick(e.coordinate);
		});
	var imperial = new maptalks.control.Scale({
		'position': {
			'bottom': '25',
			'right': '5'
		},
		'maxWidth': 100,
		'metric': true,
		'imperial': false
	});

	map.addControl(imperial);

	//如果上一次建立的vector1存在，则移除它，否则会影响标注操作
	if (map.getLayer('vector1')) {
		map.getLayer('vector1').remove();
	};
	mapTool = new maptalks.VectorLayer('vector1').addTo(map);

	pointTool = new maptalks.DrawTool({
		mode: 'Point',
		'once': true,
		draggable: false,
	}).addTo(map).disable();
	pointTool.on('drawend', function(param) {
		addcollection(param);
	});

	var maparr = map.getLayers();

	var param = {};
	for (var i = 0; i < maparr.length; i++) {
		if (map.getLayers()[i]._id == "vector") {
			var jsonarr = JSON.parse(result.json);
			for (var x = 0; x < jsonarr.length; x++) {
				param = map.getLayers()[i]._geoList[x];
				param.data = {
					name: title_arr[x]
				}
				set_draw(param);
			}

		}
	}
	currentZ = result.zindex;
	currentX = result.lng;
	currentY = result.lat;

	map.animateTo({
		center: [currentX, currentY],
		zoom: currentZ
	}, {
		duration: 1000
	});

}

function getClipboard() {
	if (window.clipboardData) {
		return (window.clipboardData.getData('Text'));
	} else if (window.netscape) {
		netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
		var clip = Components.classes['@mozilla.org/widget/clipboard;1'].createInstance(Components.interfaces.nsIClipboard);
		if (!clip) return;
		var trans = Components.classes['@mozilla.org/widget/transferable;1'].createInstance(Components.interfaces.nsITransferable);
		if (!trans) return;
		trans.addDataFlavor('text/unicode');
		clip.getData(trans, clip.kGlobalClipboard);
		var str = new Object();
		var len = new Object();
		try {
			trans.getTransferData('text/unicode', str, len);
		} catch (error) {
			return null;
		}
		if (str) {
			if (Components.interfaces.nsISupportsWString) str = str.value.QueryInterface(Components.interfaces.nsISupportsWString);
			else if (Components.interfaces.nsISupportsString) str = str.value.QueryInterface(Components.interfaces.nsISupportsString);
			else str = null;
		}
		if (str) {
			return (str.data.substring(0, len.value / 2));
		}
	}
	return null;
}

$('#label .closelable').click(function() {

	var layerwin = layer.confirm('确认关闭标注吗？', {
		btn: ['确认', '取消'] //按钮
	}, function() {
		layer.close(layerwin);
		if (issetshow) {
			issetshow = false;
			$('.dituset').hide();
		}
		clear_map();
		$('#label').hide();
		map.getLayer('vector').clear();
		if (map.getLayer('vector1')) {
			map.getLayer('vector1').clear();
		}

		layer.msg("关闭成功");
		collectionid = 0;
		drawtitle = "";
		drawdes = "";
	}, function() {

	});

});

$('#label .save').click(function() {
	layerIndex2 = layer.open({
		type: 1,
		area: ['300px', '182px'],
		fix: false,
		//不固定
		maxmin: false,
		shade: 0.4,
		anim: 3,
		shadeClose: true,
		//开启遮罩关闭
		title: '保存标注',
		closeBtn: false,
		'content': '<div class="panel-body label">' + '<div class="form form-horizontal"  style="padding:10px">' +
			'<div class="row cl" style="padding:10px;font-siez:16px !important;color:gray">' +
			'标题：<input type="text" style="width:230px" class="form-control title"  value="' + drawtitle +
			'" placeholder="请输入标题">' + '</div> ' + '<div class="text-center"  style="text-align:center;padding-top:10px" >' +
			'<input class="btn btn-success radius" type="button" onclick="add_draw_collection()" value="保存标注">' +
			'<input class="btn btn-danger radius" style="margin-left:20px" type="button" onclick="layer.close(layerIndex2)" value="关闭">' +
			'</div> ' + '</div>' + '</div>',
	});

});

$('#label .sharedraw').click(function() {
	if (!collectionid) {
		layer.msg('请先保存后再分享');
		return
	}

	if (issetshow) {
		issetshow = false;
		$('.dituset').hide();
	}
	var c = new Base64();
	var id = c.encode("'" + collectionid + "'");
	var url = 'https://17ditu.com?markid=' + id;
	url = getshorturl(url);

	plus.share.sendWithSystem({
		content: sharetitle,
		href: url
	}, function() {

	}, function(e) {

	});
});

function add_draw_collection() {

	var title = $('.label .title').val();
	var des = $('.label .des').val();
	if (title == '请输入标题' || !title) {
		layer.msg('请输入标题');
		return;
	}

	var jsonarr = [];
	var titlearr = [];
	var desarr = [];
	var layerarr = [];
	if (map.getLayer('vector')) {
		layerarr = map.getLayer('vector')._geoList;
	}

	for (var i = 0; i < layerarr.length; i++) {
		jsonarr.push(JSON.stringify(layerarr[i]))
		titlearr.push(layerarr[i].data.name);
		desarr.push(layerarr[i].data.content);
	}
	layerarr = [];
	if (map.getLayer('vector1')) {
		layerarr = map.getLayer('vector1')._geoList;
	}
	for (var i = 0; i < layerarr.length; i++) {
		jsonarr.push(JSON.stringify(layerarr[i]));
		titlearr.push(layerarr[i].data.name);
		desarr.push(layerarr[i].data.content);
	}

	if (!jsonarr.length) {
		layer.msg('未进行标注');
		return;
	}

	if (usertype == "0") {
		layer.confirm('登录后可以保存标注，现在登录？', {
			btn: ['去登录', '算了'] //按钮
		}, function() {
			window.location.href = "../user/login.html";
		}, function() {

		});
		return;
	};
	layer.close(layerIndex2);
	$.ajax({
		type: "post",
		url: request + "/dituapi/tool/addDrawCollection",
		async: true,
		data: {
			'type': 'type',
			'json': JSON.stringify(jsonarr),
			'title_arr': JSON.stringify(titlearr),
			'des_arr': JSON.stringify(desarr),
			'title': title,
			'des': des,
			'id': collectionid,
			'mapid': currentMapId,
			'usertype': usertype,
			token: token,
			zindex: currentZ,
			'lng': currentX,
			'lat': currentY
		},
		success: function(result) {
			result = JSON.parse(result);
			if (result.status == 0) {

				collectionid = result.res;
				layer.msg('标注保存成功,可在个人中心中查看');
			} else if (result.status == 2222) {
				layer.msg('标注收藏个数已达上限');
			} else {
				layer.msg('保存失败');
			}
		}
	});

}





function copyurl(event) {
	const range = document.createRange();
	range.selectNode(document.getElementById('shareurl'));

	const selection = window.getSelection();
	if (selection.rangeCount > 0) selection.removeAllRanges();
	selection.addRange(range);
	document.execCommand('copy');
	layer.tips('复制成功！', '#copyurlbtn', {
		tips: [1, '#006400'],
		time: 2000
	});
};
//添加事件

function addcollection(param) {


	var test = mapTool.addGeometry(param.geometry);
	//	param.geometry.type = "Point"
	if (param.geometry.type == "Polygon") {
		var lineTips = null;
		lineTips = {
			'title': '面标注',
			'content': '<div class="edit_content area">  <div class="content_item "><div class="content_left"><div class="edit_content_item "><span class="edit_label">名称：</span> <input type="text" placeholder="面标注" value="面标注" maxlength="15" class="edit_input form-control"></div> <br/></div> <div class="edit_sign_btn"><div class="edit_preview_marker marker_icon marker_icon_1"></div> </div></div> <div class="edit_btn_group "><!----> <!----> <a href="javascript:;" class="btn btn-info btn-sm  text-uppercase waves-effect waves-light editor">编辑</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:;" class="btn btn-danger btn-sm  text-uppercase waves-effect waves-light delete">删除</a> </div></div>',
			'width': 250,
			'autoOpenOn': true,
			'dy': 0
		};

		area_tips = new maptalks.ui.InfoWindow(lineTips);
		area_tips.addTo(map).show(param.coordinate);
		$('.area .edit_input').keyup(function() {
			param.geometry.data = {
				name: $('.area .edit_input').val()
			};
		});

		if (param.geometry.data) {
			$('.area .edit_input').val(param.geometry.data.name);
		}
		param.geometry.data = {
			name: $('.area .edit_input').val()
		};
		//点击关闭隐藏标注，隐藏标注编辑
		$('.maptalks-close').click(function() {
			hide_areaBox();
		});

		$('.editor').click(function() {
			if (box_show) {
				return;
			}
			box_show = true;
			area_editor(param.coordinate, param);
		});




		$('.area .delete').click(function() {
			param.geometry.remove();
			hide_areaBox();
			area_tips.remove();
		});



		param.geometry.addEventListener('touchstart',
			function(e) {
				if (param.geometry.iscollection == true) {
					area_tips.options.content =
						'<div class="edit_content area"> <div class="content_item "><div class="content_left"><div class="edit_content_item "><span class="edit_label">名称：</span> <input type="text" placeholder="面标注" value="面标注" maxlength="15" class="edit_input form-control"></div> <br/></div> <div class="edit_sign_btn"><div class="edit_preview_marker marker_icon marker_icon_1"></div> </div></div> <div class="edit_btn_group "><!----> <!----> <a href="javascript:;" class="btn btn-info btn-sm  text-uppercase waves-effect waves-light editor">编辑</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:;" class="btn btn-danger btn-sm  text-uppercase waves-effect waves-light delete" >删除</a> </div></div>';
				}
				area_tips.addTo(map).show(param.coordinate);
				hide_pointBox();
				hide_lineBox();
				hide_areaBox();
				$('.area .edit_input').keyup(function() {
					param.geometry.data = {
						name: $('.area .edit_input').val()
					};
				});

				if (param.geometry.data) {
					$('.area .edit_input').val(param.geometry.data.name);
				}
				param.geometry.data = {
					name: $('.area .edit_input').val()
				};


				$('.area .delete').click(function() {
					param.geometry.remove();
					hide_areaBox();
					area_tips.remove();
				});

				$('.editor').click(function() {
					if (box_show) {
						return;
					}
					box_show = true;
					area_editor(param.coordinate, param);
				});
				$('.maptalks-close').click(function() {
					hide_areaBox();
				});
			});

	}
	if (param.geometry.type == "LineString") {
		var distance = 0;
		var arr = param.geometry._coordinates;
		for (var i = 1; i < arr.length; i++) {
			distance += getDisatnce(arr[i - 1].y, arr[i].y, arr[i - 1].x, arr[i].x);
		}
		var lineTips = null;
		lineTips = {
			'title': '线标注',
			'content': '<div class="edit_content line"><div class="content_item "><div class="content_left"><div class="edit_content_item "><span class="edit_label">名称：</span> <input type="text" placeholder="线标注" value="线标注" maxlength="15" class="edit_input form-control"></div> <br/><div class="edit_content_item "><span class="edit_label">长度</span> ' +
				distance.toFixed(5) +
				'千米</div></div> <div class="edit_sign_btn"><div class="edit_preview_marker marker_icon marker_icon_1"></div> </div></div> <div class="edit_btn_group "><!----> <!----> <a href="javascript:;" class="btn btn-info btn-sm  text-uppercase waves-effect waves-light editor">编辑</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:;" class="btn btn-danger btn-sm  text-uppercase waves-effect waves-light delete">删除</a> </div></div>',
			'width': 250,
			'autoOpenOn': true,
			'dy': 0
		};
		line_tips = new maptalks.ui.InfoWindow(lineTips);
		line_tips.addTo(map).show(param.coordinate);
		$('.line .edit_input').keyup(function() {
			param.geometry.data = {
				name: $('.line .edit_input').val()
			};
		});

		if (param.geometry.data) {
			$('.line .edit_input').val(param.geometry.data.name);
		}
		param.geometry.data = {
			name: $('.line .edit_input').val()
		};
		//点击关闭隐藏标注，隐藏标注编辑
		$('.maptalks-close').click(function() {
			hide_lineBox();
		});
		$('.editor').click(function() {
			if (box_show) {
				return;
			}
			box_show = true;
			line_editor(param.coordinate, param);
		});


		$('.line .delete').click(function() {
			param.geometry.remove();
			line_tips.remove();
			hide_lineBox();
		});


		param.geometry.addEventListener('touchstart',
			function(e) {
				if (param.geometry.iscollection == true) {
					line_tips.options.content =
						'<div class="edit_content line"><div class="content_item "><div class="content_left"><div class="edit_content_item "><span class="edit_label">名称：</span> <input type="text" placeholder="线标注" value="线标注" maxlength="15" class="edit_input form-control"></div> <br/></div> <div class="edit_sign_btn"><div class="edit_preview_marker marker_icon marker_icon_1"></div> </div></div> <div class="edit_btn_group "><!----> <!----> <a href="javascript:;" class="btn btn-info btn-sm  text-uppercase waves-effect waves-light editor">编辑</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:;" class="btn btn-danger btn-sm  text-uppercase waves-effect waves-light delete" >删除</a> </div></div>';
				}
				line_tips.addTo(map).show(param.coordinate);
				hide_lineBox();
				hide_pointBox();
				hide_areaBox();
				$('.line .edit_input').keyup(function() {
					param.geometry.data = {
						name: $('.line .edit_input').val()
					};
				});

				if (param.geometry.data) {
					$('.line .edit_input').val(param.geometry.data.name);
				}
				param.geometry.data = {
					name: $('.line .edit_input').val()
				};


				$('.line .delete').click(function() {
					param.geometry.remove();
					line_tips.remove();
					hide_lineBox();
				});


				$('.editor').click(function() {
					if (box_show) {
						return;
					}
					box_show = true;
					line_editor(param.coordinate, param);
				});
				$('.maptalks-close').click(function() {
					hide_lineBox();
				});
			});
	}

	//两个GPS坐标间的距离
	function getDisatnce(lat1, lat2, lng1, lng2) {
		var radLat1 = rad(lat1);
		var radLat2 = rad(lat2);
		var a = radLat1 - radLat2;
		var b = rad(lng1) - rad(lng2);
		var s = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(a / 2), 2) + Math.cos(radLat1) * Math.cos(radLat2) * Math.pow(Math.sin(
			b / 2), 2)));
		s = s * 6378.137;
		// EARTH_RADIUS;
		return Math.round(s * 10000) / 10000;
	}

	function rad(d) {
		return d * Math.PI / 180.0; //经纬度转换成三角函数中度分表形式。
	}
	hide_pointBox();
	if (param.geometry.type == "Point") {
		var point = new BMap.Point(param.coordinate.x, param.coordinate.y);
		var gc = new BMap.Geocoder(); //Geocoder地址编码
		gc.getLocation(point,
			function(rs) { //getLocation函数用来解析地址信息，分别返回省市区街等 r.point里有经纬度
				var addComp = rs.addressComponents;
				var positionTips = null;
				if (param.geometry.type == "Point") {
					positionTips = {
						'title': '点标注',
						'content': '<div class="edit_content point">  <div class="content_item "><div class="content_left"><div class="edit_content_item "><span class="edit_label">名称：</span> <input type="text" placeholder="点标注" value="点标注" maxlength="15" class="edit_input form-control"></div> <br/></div> <div class="edit_sign_btn"><div class="edit_preview_marker marker_icon marker_icon_1"></div> </div></div> <div class="edit_btn_group "><!----> <!----> <a href="javascript:;" class="btn btn-info btn-sm  text-uppercase waves-effect waves-light editor">编辑</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:;" class="btn btn-danger btn-sm  text-uppercase waves-effect waves-light delete" >删除</a> </div></div>',
						'width': 250,
						'autoOpenOn': true,
						'dy': -30
					};
				}
				point_tips = new maptalks.ui.InfoWindow(positionTips);

				point_tips.addTo(map).show(param.coordinate);
				$('.point .edit_input').keyup(function() {
					param.geometry.data = {
						name: $('.point .edit_input').val()
					};
				});

				if (param.geometry.data) {
					$('.point .edit_input').val(param.geometry.data.name);
				}
				param.geometry.data = {
					name: $('.point .edit_input').val()
				};
				$('.point .delete').click(function() {
					param.geometry.remove();
					point_tips.remove();
					hide_pointBox();
				});


				add_event(param.coordinate);

				param.geometry.addEventListener('touchstart',
					function(e) {
						if (param.geometry.iscollection == true) {
							point_tips.options.content =
								'<div class="edit_content point"> <div class="content_item "><div class="content_left"><div class="edit_content_item "><span class="edit_label">名称：</span> <input type="text" placeholder="点标注" value="点标注" maxlength="15" class="edit_input form-control"></div> <br/></div> <div class="edit_sign_btn"><div class="edit_preview_marker marker_icon marker_icon_1"></div> </div></div> <div class="edit_btn_group "><!----> <!----><a href="javascript:;" class="btn btn-info btn-sm  text-uppercase waves-effect waves-light editor">编辑</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <a href="javascript:;" class="btn btn-danger btn-sm  text-uppercase waves-effect waves-light delete" >删除</a> </div></div>';
						}
						point_tips.addTo(map).show(param.coordinate);

						hide_lineBox();
						hide_pointBox();
						hide_areaBox();
						$('.point .edit_input').keyup(function() {
							param.geometry.data = {
								name: $('.point .edit_input').val()
							};
						});

						if (param.geometry.data) {
							$('.point .edit_input').val(param.geometry.data.name);
						}
						param.geometry.data = {
							name: $('.point .edit_input').val()
						};


						$('.point .delete').click(function() {
							param.geometry.remove();
							point_tips.remove();
							hide_pointBox();
						});

						add_event(param.coordinate);
					});
			});
	}

	//面编辑
	function area_editor(param, tool) {
		if (area_box) {
			area_box.remove();
		}

		area_box = new maptalks.ui.UIMarker([param.x, param.y], {
			'draggable': false,
			'dx': 0,
			'dy': 120,
			'eventsPropagation': false,
			'content': '<div class="edit_sign_div line_editor area"><div class="edit_sign_div_inner clearfix"><div><div class="edit_box_li"><span class="edit_label">线条</span><div class="edit_stork_box" > <div id="select-comment"><div id="select"><p class="seleted-item"></p><i id="select-img"class="fa fa-angle-down"></i></div><ul id="select-item"><li line="sloid"><p class="seleted-item1"line="sloid"></p><p class="seleted-hover"line="sloid"></p></li><li line="dashed"><p class="seleted-item2"line="dashed"></p><p class="seleted-hover"line="dashed"></p></li></ul></div>  </div></div> <div class="edit-box-li"><span class="edit_label">颜色</span> <div class="edit_stork_box"><div class="select_color edit_color"><div title="#f75564" class="color_box_com" style="background-color: rgb(247, 85, 100);"></div><div title="#f5ec00" class="color_box_com" style="background-color: rgb(245, 236, 0);"></div><div title="#c9de00" class="color_box_com" style="background-color: rgb(201, 222, 0);"></div><div title="#40b22e" class="color_box_com" style="background-color: rgb(64, 178, 46);"></div><div title="#00a14f" class="color_box_com" style="background-color: rgb(0, 161, 79);"></div><div title="#00add0" class="color_box_com" style="background-color: rgb(0, 173, 208);"></div><div title="#2186f8" class="color_box_com" style="background-color: rgb(33, 134, 248);"></div><div title="#385aaf" class="color_box_com" style="background-color: rgb(56, 90, 175);"></div><div title="#862c97" class="color_box_com" style="background-color: rgb(134, 44, 151);"></div><div title="#b6004a" class="color_box_com" style="background-color: rgb(182, 0, 74);"></div><div title="#ee3129" class="color_box_com" style="background-color: rgb(238, 49, 41);"></div><div title="#ff9200" class="color_box_com" style="background-color: rgb(255, 146, 0);"></div><div title="#ffb200" class="color_box_com" style="background-color: rgb(255, 178, 0);"></div><div title="#804e44" class="color_box_com" style="background-color: rgb(128, 78, 68);"></div><div title="#f9f89b" class="color_box_com" style="background-color: rgb(249, 248, 155);"></div><div title="#e4ef99" class="color_box_com" style="background-color: rgb(228, 239, 153);"></div><div title="#addda6" class="color_box_com" style="background-color: rgb(173, 221, 166);"></div><div title="#5cd2a6" class="color_box_com" style="background-color: rgb(92, 210, 166);"></div><div title="#7dd7eb" class="color_box_com" style="background-color: rgb(125, 215, 235);"></div><div title="#96c3ff" class="color_box_com" style="background-color: rgb(150, 195, 255);"></div><div title="#a4b5da" class="color_box_com" style="background-color: rgb(164, 181, 218);"></div><div title="#cda2d2" class="color_box_com" style="background-color: rgb(205, 162, 210);"></div><div title="#e194ad" class="color_box_com" style="background-color: rgb(225, 148, 173);"></div><div title="#fc9793" class="color_box_com" style="background-color: rgb(252, 151, 147);"></div><div title="#ffd090" class="color_box_com" style="background-color: rgb(255, 208, 144);"></div><div title="#ffdd3c" class="color_box_com" style="background-color: rgb(255, 221, 60);"></div><div title="#b88f87" class="color_box_com" style="background-color: rgb(184, 143, 135);"></div><div title="#ffffff" class="color_box_com" style="background-color: rgb(255, 255, 255);"></div><div title="#cccccc" class="color_box_com" style="background-color: rgb(204, 204, 204);"></div><div title="#777777" class="color_box_com" style="background-color: rgb(119, 119, 119);"></div><div title="#000000" class="color_box_com" style="background-color: rgb(0, 0, 0);"></div></div></div></div> <div class="edit_box_li"><span class="edit_label">线宽</span> <div class="edit_stork_box edit_popup_slider"> <div id="line_width"></div> </div></div> <br/><div class="edit_box_li"><span class="edit_label opacity">透明度</span> <div class="edit_stork_box edit_popup_slider"> <div id="opacity"></div> </div></div></div> <div class="to_left_tria"></div><i class="fa fa-close areaclose" style="position:absolute;right:5px;top:2px;font-size:18px;"></i></div>'
		});

		area_box.addTo(map).show();
		$('.areaclose').on("touchstart", function() {
			box_show = false;
			area_box.hide();
		});
		$("#line_width").slider({
			orientation: "horizontal",
			range: "min",
			max: 50,
			value: 2,
			min: 1,
			slide: refreshSwatch
		});
		$("#opacity").slider({
			orientation: "horizontal",
			range: "min",
			max: 10,
			value: 4,
			min: 0,
			slide: refreshOpciaty
		});

		if (tool) {
			$("#line_width").slider("value", tool.geometry._symbol.lineWidth);
			$("#opacity").slider("value", tool.geometry._symbol.polygonOpacity * 10);
			if (tool.geometry._symbol.lineDasharray && tool.geometry._symbol.lineDasharray.length != 0) {
				$('.area  #select p')[0].style.borderBottom = "2px dashed gray";
			} else {
				$('.area #select p')[0].style.borderBottom = "2px solid  gray";
			}
		} else {
			$("#line_width").slider("value", 2);
			$("#opacity").slider("value", 4);
		}

		function refreshOpciaty() {
			map.identify({
					'coordinate': param,
					'layers': [mapTool]
				},
				function(geos) {
					geos = layerappcontrol(geos, param, "Polygon");
					if (geos.length === 0) {
						return;
					}
					geos.forEach(function(g) {
						g.updateSymbol({
							'lineJoin': 'round', //miter, round, bevel
							'lineCap': 'round', //butt, round, square
							'polygonOpacity': $("#opacity").slider("value") / 10
						});
					});
				}
			);
		}

		function refreshSwatch() {
			map.identify({
					'coordinate': param,
					'layers': [mapTool]
				},
				function(geos) {
					geos = layerappcontrol(geos, param, "Polygon");
					if (geos.length === 0) {
						return;
					}
					geos.forEach(function(g) {
						g.updateSymbol({
							'lineJoin': 'round', //miter, round, bevel
							'lineCap': 'round', //butt, round, square
							'lineWidth': $("#line_width").slider("value")
						});
					});
				}
			);
		}

		$('.area #select').on("touchstart", function() {
			if (!selected) {
				$('.area #select-item').show(100)
				selected = true;
			} else {
				$('.area #select-item').hide(100)
				selected = false;
			}
		});

		$('.area #select-item .seleted-hover').on("touchstart", function() {
			var _this = this;
			var line = _this.getAttribute('line');
			var arr = [];

			$('.area #select-item').hide(100)
			selected = false;
			if (line == 'dashed') {
				arr = [5, 5, 5];
				$('.area  #select p')[0].style.borderBottom = "2px dashed gray";
			} else {
				$('.area #select p')[0].style.borderBottom = "2px solid gray";
			}
			map.identify({
					'coordinate': param,
					'layers': [mapTool]
				},
				function(geos) {
					geos = layerappcontrol(geos, param, "Polygon");
					if (geos.length === 0) {
						return;
					}
					geos.forEach(function(g) {
						g.updateSymbol({
							'lineDasharray': arr
						});
					});
				}
			);

		});

		$('.color_box_com').on("touchstart", function() {
			var _this = this;
			var color = _this.getAttribute('title');
			map.identify({
					'coordinate': param,
					'layers': [mapTool]
				},
				function(geos) {
					geos = layerappcontrol(geos, param, "Polygon");
					if (geos.length === 0) {
						return;
					}
					geos.forEach(function(g) {
						g.updateSymbol({
							'lineColor': color,
							'polygonFill': color,
							'lineJoin': 'round', //miter, round, bevel
							'lineCap': 'round', //butt, round, square
						});
					});
				}
			);
		});
	}

	function layerappcontrol(geos, param, type) {
		return geos;
		geos = mapTool._geoList
		var geos1 = [];
		var arr = geos;
		geos = [];
		for (var i = 0; i < arr.length; i++) {
			if (arr[i].type == type) {
				geos.push(arr[i])
			}
		}
		if (geos.length > 1) {
			var count = 0;
			var res = 0;
			for (var i = 0; i < geos.length; i++) {
				var len = geos[i]._coordinates.length - 1;
				if (geos[i]._coordinates[len].x == param.x && geos[i]._coordinates[len].y == param.y) {
					count = i;
					break;
				} else {
					if (i == 0) {
						res = Math.abs(geos[i]._coordinates[len].x - param.x)
						count = 0;
					} else {
						if (res > Math.abs(geos[i]._coordinates[len].x - param.x)) {
							res = Math.abs(geos[i]._coordinates[len].x - param.x);
							count = i;
						}
					}
				}
			}
			geos1[0] = geos[count];
		} else {
			geos1 = geos;
		}
		return geos1;
	}
	//线编辑
	function line_editor(param, tool) {

		if (line_box) {
			line_box.remove();
		}

		line_box = new maptalks.ui.UIMarker([param.x, param.y], {
			'draggable': false,
			'dx': 0,
			'dy': 120,
			'eventsPropagation': false,
			'content': '<div class="edit_sign_div line_editor line"><div class="edit_sign_div_inner clearfix"><div><div class="edit_box_li"><span class="edit_label">线条</span><div class="edit_stork_box" > <div id="select-comment"><div id="select"><p class="seleted-item"></p><i id="select-img"class="fa fa-angle-down"></i></div><ul id="select-item"><li line="sloid"><p class="seleted-item1"line="sloid"></p><p class="seleted-hover"line="sloid"></p></li><li line="dashed"><p class="seleted-item2"line="dashed"></p><p class="seleted-hover"line="dashed"></p></li></ul></div>  </div></div> <div class="edit-box-li"><span class="edit_label">颜色</span> <div class="edit_stork_box"><div class="select_color edit_color"><div title="#f75564" class="color_box_com" style="background-color: rgb(247, 85, 100);"></div><div title="#f5ec00" class="color_box_com" style="background-color: rgb(245, 236, 0);"></div><div title="#c9de00" class="color_box_com" style="background-color: rgb(201, 222, 0);"></div><div title="#40b22e" class="color_box_com" style="background-color: rgb(64, 178, 46);"></div><div title="#00a14f" class="color_box_com" style="background-color: rgb(0, 161, 79);"></div><div title="#00add0" class="color_box_com" style="background-color: rgb(0, 173, 208);"></div><div title="#2186f8" class="color_box_com" style="background-color: rgb(33, 134, 248);"></div><div title="#385aaf" class="color_box_com" style="background-color: rgb(56, 90, 175);"></div><div title="#862c97" class="color_box_com" style="background-color: rgb(134, 44, 151);"></div><div title="#b6004a" class="color_box_com" style="background-color: rgb(182, 0, 74);"></div><div title="#ee3129" class="color_box_com" style="background-color: rgb(238, 49, 41);"></div><div title="#ff9200" class="color_box_com" style="background-color: rgb(255, 146, 0);"></div><div title="#ffb200" class="color_box_com" style="background-color: rgb(255, 178, 0);"></div><div title="#804e44" class="color_box_com" style="background-color: rgb(128, 78, 68);"></div><div title="#f9f89b" class="color_box_com" style="background-color: rgb(249, 248, 155);"></div><div title="#e4ef99" class="color_box_com" style="background-color: rgb(228, 239, 153);"></div><div title="#addda6" class="color_box_com" style="background-color: rgb(173, 221, 166);"></div><div title="#5cd2a6" class="color_box_com" style="background-color: rgb(92, 210, 166);"></div><div title="#7dd7eb" class="color_box_com" style="background-color: rgb(125, 215, 235);"></div><div title="#96c3ff" class="color_box_com" style="background-color: rgb(150, 195, 255);"></div><div title="#a4b5da" class="color_box_com" style="background-color: rgb(164, 181, 218);"></div><div title="#cda2d2" class="color_box_com" style="background-color: rgb(205, 162, 210);"></div><div title="#e194ad" class="color_box_com" style="background-color: rgb(225, 148, 173);"></div><div title="#fc9793" class="color_box_com" style="background-color: rgb(252, 151, 147);"></div><div title="#ffd090" class="color_box_com" style="background-color: rgb(255, 208, 144);"></div><div title="#ffdd3c" class="color_box_com" style="background-color: rgb(255, 221, 60);"></div><div title="#b88f87" class="color_box_com" style="background-color: rgb(184, 143, 135);"></div><div title="#ffffff" class="color_box_com" style="background-color: rgb(255, 255, 255);"></div><div title="#cccccc" class="color_box_com" style="background-color: rgb(204, 204, 204);"></div><div title="#777777" class="color_box_com" style="background-color: rgb(119, 119, 119);"></div><div title="#000000" class="color_box_com" style="background-color: rgb(0, 0, 0);"></div></div></div></div> <div class="edit_box_li"><span class="edit_label">线宽</span> <div class="edit_stork_box edit_popup_slider"> <div id="line_width_o"></div> </div></div></div> <div class="to_left_tria"></div><i class="fa fa-close lineclose" style="position:absolute;right:5px;top:2px;font-size:18px;"></i></div>'
		});

		line_box.addTo(map).show();
		$('.lineclose').on("touchstart", function() {
			box_show = false;
			line_box.hide();
		});
		$("#line_width_o").slider({
			orientation: "horizontal",
			range: "min",
			max: 50,
			value: 2,
			min: 1,
			slide: refreshSwatch
		});
		if (tool) {
			$("#line_width_o").slider("value", tool.geometry._symbol.lineWidth);
			if (tool.geometry._symbol.lineDasharray && tool.geometry._symbol.lineDasharray.length != 0) {
				$('.line #select p')[0].style.borderBottom = "2px dashed gray";
			} else {
				$('.line #select p')[0].style.borderBottom = "2px solid  gray";
			}
		} else {
			$("#line_width_o").slider("value", 2);
		}

		function refreshSwatch() {
			map.identify({
					'coordinate': param,
					'layers': [mapTool]
				},
				function(geos) {
					geos = layerappcontrol(geos, param, "LineString");
					if (geos.length === 0) {
						return;
					}
					geos.forEach(function(g) {
						g.updateSymbol({
							'lineJoin': 'round',
							'lineCap': 'round',
							'lineWidth': $("#line_width_o").slider("value")
						});
					});
				}
			);
		}
		$('.line #select').on("touchstart", function() {

			if (!selected) {
				$('.line #select-item').show(100)
				selected = true;
			} else {
				$('.line #select-item').hide(100)
				selected = false;
			}
		});
		$('.line #select-item .seleted-hover').on("touchstart", function() {
			var _this = this;
			var line = _this.getAttribute('line');
			var arr = [];

			$('.line  #select-item').hide(100)
			selected = false;
			if (line == 'dashed') {
				arr = [5, 5, 5];
				$('.line #select p')[0].style.borderBottom = "2px dashed gray";
			} else {
				$('.line #select p')[0].style.borderBottom = "2px solid gray";
			}
			map.identify({
					'coordinate': param,
					'layers': [mapTool]
				},
				function(geos) {
					var geos2 = layerappcontrol(geos, param, "LineString");
					geos = geos2;
					if (geos.length === 0) {
						return;
					}
					geos.forEach(function(g) {
						g.updateSymbol({
							'lineDasharray': arr
						});
					});
				}
			);

		});


		$('.line_editor .color_box_com').on("touchstart", function() {
			var _this = this;
			var color = _this.getAttribute('title');
			map.identify({
					'coordinate': param,
					'layers': [mapTool]
				},
				function(geos) {
					geos = layerappcontrol(geos, param, "LineString");

					if (geos.length === 0) {
						return;
					}
					geos.forEach(function(g) {
						g.updateSymbol({
							'lineColor': color,
							'lineJoin': 'round', //miter, round, bevel
							'lineCap': 'round', //butt, round, square
						});
					});
				}
			);
		});
	}

	function add_event(param) {
		$('.editor').on("touchstart", function() {
			if (box_show) {
				return;
			}
			box_show = true;
			point_editor(param);
		});
		//点击关闭隐藏标注，隐藏标注编辑
		$('.maptalks-close').on("touchstart", function() {
			hide_pointBox();
		});
	}
	//标点编辑
	function point_editor(param) {
		if (point_box) {
			point_box.remove();
		}
		point_box = new maptalks.ui.UIMarker([param.x, param.y], {
			'draggable': false,
			'single': false,
			'dx': 0,
			'dy': pointY,
			'content': '<div class="edit_sign_div"><div class="edit_sign_div_inner"><div class="marker_icon_list"><div class="marker_icon_inline marker_icon marker_icon_0"><img src="https://cdn.17ditu.com/static/images/location/location.png"/></div><div class="marker_icon_inline marker_icon marker_icon_1"><img src="https://cdn.17ditu.com/static/images/location/location1.png"/></div><div class="marker_icon_inline marker_icon marker_icon_2"><img src="https://cdn.17ditu.com/static/images/location/location2.png"/></div><div class="marker_icon_inline marker_icon marker_icon_3"><img src="https://cdn.17ditu.com/static/images/location/location3.png"/></div><div class="marker_icon_inline marker_icon marker_icon_4"><img src="https://cdn.17ditu.com/static/images/location/location4.png"/></div><div class="marker_icon_inline marker_icon marker_icon_5"><img src="https://cdn.17ditu.com/static/images/location/location5.png"/></div><div class="marker_icon_inline marker_icon marker_icon_6"><img src="https://cdn.17ditu.com/static/images/location/location6.png"/></div><div class="marker_icon_inline marker_icon marker_icon_7"><img src="https://cdn.17ditu.com/static/images/location/location7.png"/></div><div class="marker_icon_inline marker_icon marker_icon_8"><img src="https://cdn.17ditu.com/static/images/location/location8.png"/></div><div class="marker_icon_inline marker_icon marker_icon_9"><img src="https://cdn.17ditu.com/static/images/location/location9.png"/></div><div class="marker_icon_inline marker_icon marker_icon_10"><img src="https://cdn.17ditu.com/static/images/location/location10.png"/></div><div class="marker_icon_inline marker_icon marker_icon_11"><img src="https://cdn.17ditu.com/static/images/location/location11.png"/></div><div class="marker_icon_inline marker_icon marker_icon_12"><img src="https://cdn.17ditu.com/static/images/location/location12.png"/></div><div class="marker_icon_inline marker_icon marker_icon_13"><img src="https://cdn.17ditu.com/static/images/location/location13.png"/></div><div class="marker_icon_inline marker_icon marker_icon_14"><img src="https://cdn.17ditu.com/static/images/location/location14.png"/></div><div class="marker_icon_inline marker_icon marker_icon_15"><img src="https://cdn.17ditu.com/static/images/location/location15.png"/></div><div class="marker_icon_inline marker_icon marker_icon_16"><img src="https://cdn.17ditu.com/static/images/location/location16.png"/></div><div class="marker_icon_inline marker_icon marker_icon_17"><img src="https://cdn.17ditu.com/static/images/location/location17.png"/></div><div class="marker_icon_inline marker_icon marker_icon_18"><img src="https://cdn.17ditu.com/static/images/location/location18.png"/></div><div class="marker_icon_inline marker_icon marker_icon_19"><img src="https://cdn.17ditu.com/static/images/location/location19.png"/></div><div class="marker_icon_inline marker_icon marker_icon_20"><img src="https://cdn.17ditu.com/static/images/location/location20.png"/></div><div class="marker_icon_inline marker_icon marker_icon_20"><img src="https://cdn.17ditu.com/static/images/location/icon_marka.png"/></div><div class="marker_icon_inline marker_icon marker_icon_20"><img src="https://cdn.17ditu.com/static/images/location/icon_markb.png"/></div><div class="marker_icon_inline marker_icon marker_icon_20"><img src="https://cdn.17ditu.com/static/images/location/icon_markc.png"/></div><div class="marker_icon_inline marker_icon marker_icon_20"><img src="https://cdn.17ditu.com/static/images/location/icon_markd.png"/></div><div class="marker_icon_inline marker_icon marker_icon_20"><img src="https://cdn.17ditu.com/static/images/location/icon_marke.png"/></div><div class="marker_icon_inline marker_icon marker_icon_20"><img src="https://cdn.17ditu.com/static/images/location/icon_markf.png"/></div><div class="marker_icon_inline marker_icon marker_icon_20"><img src="https://cdn.17ditu.com/static/images/location/icon_markg.png"/></div></div></div><div class="to_left_tria"></div><i class="fa fa-close pointclose" style="position:absolute;right:5px;top:2px;font-size:18px;"></i></div>'
		});

		point_box.addTo(map).show();
		if (pointY == 50) {
			pointY = 120;
		}
		$('.pointclose').on("touchstart", function() {
			box_show = false;
			point_box.hide();
		});
		$('.marker_icon_inline img').on("touchstart", function() {

			var _this = this;
			map.identify({
					'coordinate': param,
					'layers': [mapTool]
				},
				function(geos) {

					if (geos.length === 0) {
						return;
					}
					geos.forEach(function(g) {
						g.updateSymbol({
							'markerFile': _this.getAttribute('src'),
							'markerWidth': 30,
						});
					});
				}
			);
		});
	}

}

function set_draw(param) {
	if (param.type == "Polygon") {
		var lineTips = null;
		lineTips = {
			'title': '面标注',
			'content': '<div class="edit_content area"> <div class="content_item "><div class="content_left"><div class="edit_content_item "><span class="edit_label">名称：</span> <input type="text" placeholder="面标注" value="面标注" maxlength="15" class="edit_input form-control"></div> <br/></div> <div class="edit_sign_btn"><div class="edit_preview_marker marker_icon marker_icon_1"></div> </div></div> <div class="edit_btn_group "><!----> <!----> <a href="javascript:;" class="btn btn-info btn-sm  text-uppercase waves-effect waves-light editor">编辑</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:;" class="btn btn-danger btn-sm  text-uppercase waves-effect waves-light delete">删除</a> </div></div>',
			'width': 250,
			'autoOpenOn': true,
			'dy': 0
		};

		area_tips = new maptalks.ui.InfoWindow(lineTips);
		area_tips.addTo(map).show(param._coordinates[param._coordinates.length - 1]);
		$('.area .edit_input').keyup(function() {
			param.data = {
				name: $('.area .edit_input').val()
			};
		});

		if (param.data) {
			$('.area .edit_input').val(param.data.name);
		}
		if (hidedraw) {
			$('.edit_btn_group ').hide();
			$('.edit_content_item  input').attr("readonly", "readonly");
		}
		//点击关闭隐藏标注，隐藏标注编辑
		$('.maptalks-close').on("touchstart", function() {
			hide_areaBox();
		});

		$('.editor').on("touchstart", function() {
			if (box_show) {
				return;
			}
			box_show = true;
			area_editor(param._coordinates[param._coordinates.length - 1], param);
		});



		$('.area .delete').on("touchstart", function() {
			param.remove();
			hide_areaBox();
			area_tips.remove();
		});



		param.addEventListener('touchstart',
			function(e) {
				if (param.iscollection == true) {
					area_tips.options.content =
						'<div class="edit_content area"> <div class="content_item "><div class="content_left"><div class="edit_content_item "><span class="edit_label">名称：</span> <input type="text" placeholder="面标注" value="面标注" maxlength="15" class="edit_input form-control"></div> <br/></div> <div class="edit_sign_btn"><div class="edit_preview_marker marker_icon marker_icon_1"></div> </div></div> <div class="edit_btn_group "><!----> <!----> <a href="javascript:;" class="btn btn-info btn-sm  text-uppercase waves-effect waves-light editor">编辑</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:;" class="btn btn-danger btn-sm  text-uppercase waves-effect waves-light delete" >删除</a> </div></div>';
				}
				area_tips.addTo(map).show(param._coordinates[param._coordinates.length - 1]);
				hide_pointBox();
				hide_lineBox();
				hide_areaBox();
				$('.area .edit_input').keyup(function() {
					param.data = {
						name: $('.area .edit_input').val()
					};
				});


				if (param.data) {
					$('.area .edit_input').val(param.data.name);
				}
				if (hidedraw) {
					$('.edit_btn_group ').hide();
					$('.edit_content_item  input').attr("readonly", "readonly");
				}


				$('.area .delete').click(function() {
					param.remove();
					hide_areaBox();
					area_tips.remove();
				});

				$('.editor').click(function() {
					if (box_show) {
						return;
					}
					box_show = true;
					area_editor(param._coordinates[param._coordinates.length - 1], param);
				});
				$('.maptalks-close').click(function() {
					hide_areaBox();
				});
			});

	}
	if (param.type == "LineString") {
		var distance = 0;
		var arr = param._coordinates;
		for (var i = 1; i < arr.length; i++) {
			distance += getDisatnce(arr[i - 1].y, arr[i].y, arr[i - 1].x, arr[i].x);
		}
		var lineTips = null;
		lineTips = {
			'title': '线标注',
			'content': '<div class="edit_content line"> <div class="content_item "><div class="content_left"><div class="edit_content_item "><span class="edit_label">名称：</span> <input type="text" placeholder="线标注" value="线标注" maxlength="15" class="edit_input form-control"></div> <br/><div class="edit_content_item "><span class="edit_label">长度</span> ' +
				distance.toFixed(5) +
				'千米</div></div> <div class="edit_sign_btn"><div class="edit_preview_marker marker_icon marker_icon_1"></div> </div></div> <div class="edit_btn_group "><!----> <!----> <a href="javascript:;" class="btn btn-info btn-sm  text-uppercase waves-effect waves-light editor">编辑</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:;" class="btn btn-danger btn-sm  text-uppercase waves-effect waves-light delete">删除</a> </div></div>',
			'width': 250,
			'autoOpenOn': true,
			'dy': 0
		};
		line_tips = new maptalks.ui.InfoWindow(lineTips);
		line_tips.addTo(map).show(param._coordinates[param._coordinates.length - 1]);
		$('.line .edit_input').keyup(function() {
			param.data = {
				name: $('.line .edit_input').val()
			};
		});

		if (param.data) {
			$('.line .edit_input').val(param.data.name);
		}
		if (hidedraw) {
			$('.edit_btn_group ').hide();
			$('.edit_content_item  input').attr("readonly", "readonly");
		}
		//点击关闭隐藏标注，隐藏标注编辑
		$('.maptalks-close').click(function() {
			hide_lineBox();
		});
		$('.editor').click(function() {
			if (box_show) {
				return;
			}
			box_show = true;
			line_editor(param._coordinates[param._coordinates.length - 1], param);
		});


		$('.line .delete').click(function() {
			param.remove();
			line_tips.remove();
			hide_lineBox();
		});


		param.addEventListener('touchstart',
			function(e) {
				if (param.iscollection == true) {
					line_tips.options.content =
						'<div class="edit_content line">  </i><div class="content_item "><div class="content_left"><div class="edit_content_item "><span class="edit_label">名称：</span> <input type="text" placeholder="线标注" value="线标注" maxlength="15" class="edit_input form-control"></div> <br/></div> <div class="edit_sign_btn"><div class="edit_preview_marker marker_icon marker_icon_1"></div> </div></div> <div class="edit_btn_group "><!----> <!----> <a href="javascript:;" class="btn btn-info btn-sm  text-uppercase waves-effect waves-light editor">编辑</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:;" class="btn btn-danger btn-sm  text-uppercase waves-effect waves-light delete" >删除</a> </div></div>';
				}
				line_tips.addTo(map).show(param._coordinates[param._coordinates.length - 1]);
				hide_lineBox();
				hide_pointBox();
				hide_areaBox();
				$('.line .edit_input').keyup(function() {
					param.data = {
						name: $('.line .edit_input').val()
					};
				});

				if (param.data) {
					$('.line .edit_input').val(param.data.name);
				}
				if (hidedraw) {
					$('.edit_btn_group ').hide();
					$('.edit_content_item  input').attr("readonly", "readonly");
				}


				$('.line .delete').click(function() {
					param.remove();
					line_tips.remove();
					hide_lineBox();
				});


				$('.editor').click(function() {
					if (box_show) {
						return;
					}
					box_show = true;
					line_editor(param._coordinates[param._coordinates.length - 1], param);
				});
				$('.maptalks-close').click(function() {
					hide_lineBox();
				});
			});
	}


	function layerappcontrol(geos, param, type) {
		return geos;
		geos = mapTool._geoList
		var geos1 = [];
		var arr = geos;
		geos = [];
		for (var i = 0; i < arr.length; i++) {
			if (arr[i].type == type) {
				geos.push(arr[i])
			}
		}
		if (geos.length > 1) {
			var count = 0;
			var res = 0;
			for (var i = 0; i < geos.length; i++) {
				var len = geos[i]._coordinates.length - 1;
				if (geos[i]._coordinates[len].x == param.x && geos[i]._coordinates[len].y == param.y) {
					count = i;
					break;
				} else {
					if (i == 0) {
						res = Math.abs(geos[i]._coordinates[len].x - param.x)
						count = 0;
					} else {
						if (res > Math.abs(geos[i]._coordinates[len].x - param.x)) {
							res = Math.abs(geos[i]._coordinates[len].x - param.x);
							count = i;
						}
					}
				}
			}
			geos1[0] = geos[count];
		} else {
			geos1 = geos;
		}
		return geos1;
	}
	//两个GPS坐标间的距离
	function getDisatnce(lat1, lat2, lng1, lng2) {
		var radLat1 = rad(lat1);
		var radLat2 = rad(lat2);
		var a = radLat1 - radLat2;
		var b = rad(lng1) - rad(lng2);
		var s = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(a / 2), 2) + Math.cos(radLat1) * Math.cos(radLat2) * Math.pow(Math.sin(
			b / 2), 2)));
		s = s * 6378.137;
		// EARTH_RADIUS;
		return Math.round(s * 10000) / 10000;
	}

	function rad(d) {
		return d * Math.PI / 180.0; //经纬度转换成三角函数中度分表形式。
	}
	hide_pointBox();

	if (param.type == "Point") {

		var positionTips = null;
		positionTips = {
			'title': '点标注',
			'content': '<div class="edit_content point"> <div class="content_item "><div class="content_left"><div class="edit_content_item "><span class="edit_label">名称：</span> <input type="text" placeholder="点标注" value="点标注" maxlength="15" class="edit_input form-control"></div> <br/></div> <div class="edit_sign_btn"><div class="edit_preview_marker marker_icon marker_icon_1"></div> </div></div> <div class="edit_btn_group "><!----> <!----> <a href="javascript:;" class="btn btn-info btn-sm  text-uppercase waves-effect waves-light editor">编辑</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="javascript:;" class="btn btn-danger btn-sm  text-uppercase waves-effect waves-light delete" >删除</a> </div></div>',
			'width': 250,
			'autoOpenOn': true,
			'dy': -30
		};

		point_tips = new maptalks.ui.InfoWindow(positionTips);

		point_tips.addTo(map).show(param._coordinates);
		$('.point .edit_input').keyup(function() {
			param.data = {
				name: $('.point .edit_input').val()
			};
		});

		if (param.data) {
			$('.point .edit_input').val(param.data.name);
		}
		if (hidedraw) {
			$('.edit_btn_group ').hide();
			$('.edit_content_item  input').attr("readonly", "readonly");
		}
		$('.point .delete').click(function() {
			param.remove();
			placeMarker.remove();
			point_tips.remove();
			hide_pointBox();
		});

		add_event(param._coordinates);


		param.addEventListener('touchstart',
			function(e) {

				point_tips.addTo(map).show(param._coordinates);

				hide_lineBox();
				hide_pointBox();
				hide_areaBox();
				$('.point .edit_input').keyup(function() {
					param.data = {
						name: $('.point .edit_input').val()
					};
				});
				$('.point .edit_textarea').keyup(function() {
					param.data = {
						name: $('.point .edit_input').val()
					};
				});
				if (param.data) {
					$('.point .edit_input').val(param.data.name);
				}
				if (hidedraw) {
					$('.edit_btn_group ').hide();
					$('.edit_content_item  input').attr("readonly", "readonly");
				}


				$('.point .delete').click(function() {
					param.remove();
					placeMarker.remove();
					point_tips.remove();
					hide_pointBox();
				});

				add_event(param._coordinates);

			});

	}

	//面编辑
	function area_editor(param, tool) {

		if (area_box) {
			area_box.remove();
		}
		
		area_box = new maptalks.ui.UIMarker([param.x, param.y], {
			'draggable': false,
			'dx': 0,
			'dy': 120,
			'eventsPropagation': false,
			'content': '<div class="edit_sign_div line_editor area_editor area"><div class="edit_sign_div_inner clearfix"><div><div class="edit_box_li"><span class="edit_label">线条</span><div class="edit_stork_box" > <div id="select-comment"><div id="select"><p class="seleted-item"></p><i id="select-img"class="fa fa-angle-down"></i></div><ul id="select-item"><li line="sloid"><p class="seleted-item1"line="sloid"></p><p class="seleted-hover"line="sloid"></p></li><li line="dashed"><p class="seleted-item2"line="dashed"></p><p class="seleted-hover"line="dashed"></p></li></ul></div>  </div></div> <div class="edit-box-li"><span class="edit_label">颜色</span> <div class="edit_stork_box"><div class="select_color edit_color"><div title="#f75564" class="color_box_com" style="background-color: rgb(247, 85, 100);"></div><div title="#f5ec00" class="color_box_com" style="background-color: rgb(245, 236, 0);"></div><div title="#c9de00" class="color_box_com" style="background-color: rgb(201, 222, 0);"></div><div title="#40b22e" class="color_box_com" style="background-color: rgb(64, 178, 46);"></div><div title="#00a14f" class="color_box_com" style="background-color: rgb(0, 161, 79);"></div><div title="#00add0" class="color_box_com" style="background-color: rgb(0, 173, 208);"></div><div title="#2186f8" class="color_box_com" style="background-color: rgb(33, 134, 248);"></div><div title="#385aaf" class="color_box_com" style="background-color: rgb(56, 90, 175);"></div><div title="#862c97" class="color_box_com" style="background-color: rgb(134, 44, 151);"></div><div title="#b6004a" class="color_box_com" style="background-color: rgb(182, 0, 74);"></div><div title="#ee3129" class="color_box_com" style="background-color: rgb(238, 49, 41);"></div><div title="#ff9200" class="color_box_com" style="background-color: rgb(255, 146, 0);"></div><div title="#ffb200" class="color_box_com" style="background-color: rgb(255, 178, 0);"></div><div title="#804e44" class="color_box_com" style="background-color: rgb(128, 78, 68);"></div><div title="#f9f89b" class="color_box_com" style="background-color: rgb(249, 248, 155);"></div><div title="#e4ef99" class="color_box_com" style="background-color: rgb(228, 239, 153);"></div><div title="#addda6" class="color_box_com" style="background-color: rgb(173, 221, 166);"></div><div title="#5cd2a6" class="color_box_com" style="background-color: rgb(92, 210, 166);"></div><div title="#7dd7eb" class="color_box_com" style="background-color: rgb(125, 215, 235);"></div><div title="#96c3ff" class="color_box_com" style="background-color: rgb(150, 195, 255);"></div><div title="#a4b5da" class="color_box_com" style="background-color: rgb(164, 181, 218);"></div><div title="#cda2d2" class="color_box_com" style="background-color: rgb(205, 162, 210);"></div><div title="#e194ad" class="color_box_com" style="background-color: rgb(225, 148, 173);"></div><div title="#fc9793" class="color_box_com" style="background-color: rgb(252, 151, 147);"></div><div title="#ffd090" class="color_box_com" style="background-color: rgb(255, 208, 144);"></div><div title="#ffdd3c" class="color_box_com" style="background-color: rgb(255, 221, 60);"></div><div title="#b88f87" class="color_box_com" style="background-color: rgb(184, 143, 135);"></div><div title="#ffffff" class="color_box_com" style="background-color: rgb(255, 255, 255);"></div><div title="#cccccc" class="color_box_com" style="background-color: rgb(204, 204, 204);"></div><div title="#777777" class="color_box_com" style="background-color: rgb(119, 119, 119);"></div><div title="#000000" class="color_box_com" style="background-color: rgb(0, 0, 0);"></div></div></div></div> <div class="edit_box_li"><span class="edit_label">线宽</span> <div class="edit_stork_box edit_popup_slider"> <div id="line_width"></div> </div></div> <br/><div class="edit_box_li"><span class="edit_label opacity">透明度</span> <div class="edit_stork_box edit_popup_slider"> <div id="opacity"></div> </div></div></div> <div class="to_left_tria"></div><i class="fa fa-close areaclose" style="position:absolute;right:5px;top:2px;font-size:18px;"></i></div>'
		});

		area_box.addTo(map).show();
		$('.areaclose').on("touchstart", function() {
			box_show = false;
			area_box.hide();
		});
		$("#line_width").slider({
			orientation: "horizontal",
			range: "min",
			max: 50,
			value: 2,
			min: 1,
			slide: refreshSwatch
		});
		$("#opacity").slider({
			orientation: "horizontal",
			range: "min",
			max: 10,
			value: 4,
			min: 0,
			slide: refreshOpciaty
		});
		if (tool) {
			$("#line_width").slider("value", tool._symbol.lineWidth);
			$("#opacity").slider("value", tool._symbol.polygonOpacity * 10);
			if (tool._symbol.lineDasharray && tool._symbol.lineDasharray.length != 0) {
				$('.area  #select p')[0].style.borderBottom = "2px dashed gray";
			} else {
				$('.area #select p')[0].style.borderBottom = "2px solid  gray";
			}
		} else {
			$("#line_width").slider("value", 2);
			$("#opacity").slider("value", 4);
		}

		function refreshOpciaty() {
			map.identify({
					'coordinate': param,
					'layers': [map.getLayers()[getdrawlayer()]]
				},
				function(geos) {
					geos = layerappcontrol(geos, param, "Polygon");
					if (geos.length === 0) {
						return;
					}
					geos.forEach(function(g) {
						g.updateSymbol({
							'lineJoin': 'round', //miter, round, bevel
							'lineCap': 'round', //butt, round, square
							'polygonOpacity': $("#opacity").slider("value") / 10
						});
					});
				}
			);
		}

		function refreshSwatch() {
			map.identify({
					'coordinate': param,
					'layers': [map.getLayers()[getdrawlayer()]]
				},
				function(geos) {
					geos = layerappcontrol(geos, param, "Polygon");
					if (geos.length === 0) {
						return;
					}
					geos.forEach(function(g) {
						g.updateSymbol({
							'lineJoin': 'round', //miter, round, bevel
							'lineCap': 'round', //butt, round, square
							'lineWidth': $("#line_width").slider("value")
						});
					});
				}
			);
		}

		$('.area #select').click(function() {
			if (!selected) {
				$('.area  #select-item').show(100)
				selected = true;
			} else {
				$('.area #select-item').hide(100)
				selected = false;
			}
		});

		$('.area #select-item .seleted-hover').click(function() {
			var _this = this;
			var line = _this.getAttribute('line');
			var arr = [];

			$('.area #select-item').hide(100)
			selected = false;
			if (line == 'dashed') {
				arr = [5, 5, 5];
				$('.area  #select p')[0].style.borderBottom = "2px dashed gray";
			} else {
				$('.area #select p')[0].style.borderBottom = "2px solid gray";
			}
			map.identify({
					'coordinate': param,
					'layers': [map.getLayers()[getdrawlayer()]]
				},
				function(geos) {
					geos = layerappcontrol(geos, param, "Polygon");
					if (geos.length === 0) {
						return;
					}
					geos.forEach(function(g) {
						g.updateSymbol({
							'lineDasharray': arr
						});
					});
				}
			);

		});

		$('.color_box_com').click(function() {
			var _this = this;
			var color = _this.getAttribute('title');
			map.identify({
					'coordinate': param,
					'layers': [map.getLayers()[getdrawlayer()]]
				},
				function(geos) {
					geos = layerappcontrol(geos, param, "Polygon");
					if (geos.length === 0) {
						return;
					}
					geos.forEach(function(g) {
						g.updateSymbol({
							'lineColor': color,
							'polygonFill': color,
							'lineJoin': 'round', //miter, round, bevel
							'lineCap': 'round', //butt, round, square
						});
					});
				}
			);
		});
	}

	//线编辑
	function line_editor(param, tool) {
		if (line_box) {
			line_box.remove();
		}

		line_box = new maptalks.ui.UIMarker([param.x, param.y], {
			'draggable': false,
			'dx': 0,
			'dy': 120,
			'eventsPropagation': false,
			'content': '<div class="edit_sign_div line_editor line"><div class="edit_sign_div_inner clearfix"><div><div class="edit_box_li"><span class="edit_label">线条</span><div class="edit_stork_box" > <div id="select-comment"><div id="select"><p class="seleted-item"></p><i id="select-img"class="fa fa-angle-down"></i></div><ul id="select-item"><li line="sloid"><p class="seleted-item1"line="sloid"></p><p class="seleted-hover"line="sloid"></p></li><li line="dashed"><p class="seleted-item2"line="dashed"></p><p class="seleted-hover"line="dashed"></p></li></ul></div>  </div></div> <div class="edit-box-li"><span class="edit_label">颜色</span> <div class="edit_stork_box"><div class="select_color edit_color"><div title="#f75564" class="color_box_com" style="background-color: rgb(247, 85, 100);"></div><div title="#f5ec00" class="color_box_com" style="background-color: rgb(245, 236, 0);"></div><div title="#c9de00" class="color_box_com" style="background-color: rgb(201, 222, 0);"></div><div title="#40b22e" class="color_box_com" style="background-color: rgb(64, 178, 46);"></div><div title="#00a14f" class="color_box_com" style="background-color: rgb(0, 161, 79);"></div><div title="#00add0" class="color_box_com" style="background-color: rgb(0, 173, 208);"></div><div title="#2186f8" class="color_box_com" style="background-color: rgb(33, 134, 248);"></div><div title="#385aaf" class="color_box_com" style="background-color: rgb(56, 90, 175);"></div><div title="#862c97" class="color_box_com" style="background-color: rgb(134, 44, 151);"></div><div title="#b6004a" class="color_box_com" style="background-color: rgb(182, 0, 74);"></div><div title="#ee3129" class="color_box_com" style="background-color: rgb(238, 49, 41);"></div><div title="#ff9200" class="color_box_com" style="background-color: rgb(255, 146, 0);"></div><div title="#ffb200" class="color_box_com" style="background-color: rgb(255, 178, 0);"></div><div title="#804e44" class="color_box_com" style="background-color: rgb(128, 78, 68);"></div><div title="#f9f89b" class="color_box_com" style="background-color: rgb(249, 248, 155);"></div><div title="#e4ef99" class="color_box_com" style="background-color: rgb(228, 239, 153);"></div><div title="#addda6" class="color_box_com" style="background-color: rgb(173, 221, 166);"></div><div title="#5cd2a6" class="color_box_com" style="background-color: rgb(92, 210, 166);"></div><div title="#7dd7eb" class="color_box_com" style="background-color: rgb(125, 215, 235);"></div><div title="#96c3ff" class="color_box_com" style="background-color: rgb(150, 195, 255);"></div><div title="#a4b5da" class="color_box_com" style="background-color: rgb(164, 181, 218);"></div><div title="#cda2d2" class="color_box_com" style="background-color: rgb(205, 162, 210);"></div><div title="#e194ad" class="color_box_com" style="background-color: rgb(225, 148, 173);"></div><div title="#fc9793" class="color_box_com" style="background-color: rgb(252, 151, 147);"></div><div title="#ffd090" class="color_box_com" style="background-color: rgb(255, 208, 144);"></div><div title="#ffdd3c" class="color_box_com" style="background-color: rgb(255, 221, 60);"></div><div title="#b88f87" class="color_box_com" style="background-color: rgb(184, 143, 135);"></div><div title="#ffffff" class="color_box_com" style="background-color: rgb(255, 255, 255);"></div><div title="#cccccc" class="color_box_com" style="background-color: rgb(204, 204, 204);"></div><div title="#777777" class="color_box_com" style="background-color: rgb(119, 119, 119);"></div><div title="#000000" class="color_box_com" style="background-color: rgb(0, 0, 0);"></div></div></div></div> <div class="edit_box_li"><span class="edit_label">线宽</span> <div class="edit_stork_box edit_popup_slider"> <div id="line_width_o"></div> </div></div></div> <div class="to_left_tria"></div><i class="fa fa-close lineclose" style="position:absolute;right:5px;top:2px;font-size:18px;"></i></div>'
		});

		line_box.addTo(map).show();
		$('.lineclose').on("click", function() {
			box_show = false;
			line_box.hide();
		});
		$("#line_width_o").slider({
			orientation: "horizontal",
			range: "min",
			max: 50,
			value: 2,
			min: 1,
			slide: refreshSwatch
		});
		if (tool) {
			$("#line_width_o").slider("value", tool._symbol.lineWidth);
			if (tool._symbol.lineDasharray && tool._symbol.lineDasharray.length != 0) {
				$('.line #select p')[0].style.borderBottom = "2px dashed gray";
			} else {
				$('.line #select p')[0].style.borderBottom = "2px solid  gray";
			}
		} else {
			$("#line_width_o").slider("value", 2);
		}

		function refreshSwatch() {
			map.identify({
					'coordinate': param,
					'layers': [map.getLayers()[getdrawlayer()]]
				},
				function(geos) {
					if (geos.length === 0) {
						return;
					}
					geos.forEach(function(g) {
						g.updateSymbol({
							'lineJoin': 'round',
							//miter, round, bevel
							'lineCap': 'round',
							//butt, round, square
							'lineWidth': $("#line_width_o").slider("value")
						});
					});
				});
		}
		$('.line #select').click(function() {
			if (!selected) {
				$('.line #select-item').show(100);
				selected = true;
			} else {
				$('.line #select-item').hide(100);
				selected = false;
			}
		});
		$('.line #select-item .seleted-hover').click(function() {
			var _this = this;
			var line = _this.getAttribute('line');
			var arr = [];

			$('.line #select-item').hide(100);
			selected = false;
			if (line == 'dashed') {
				arr = [5, 5, 5];
				$('.line #select p')[0].style.borderBottom = "2px dashed gray";
			} else {
				$('.line #select p')[0].style.borderBottom = "2px solid gray";
			}
			map.identify({
					'coordinate': param,
					'layers': [map.getLayers()[getdrawlayer()]]
				},
				function(geos) {
					if (geos.length === 0) {
						return;
					}
					geos.forEach(function(g) {
						g.updateSymbol({
							'lineDasharray': arr
						});
					});
				});

		});

		$('.color_box_com').click(function() {
			var _this = this;
			var color = _this.getAttribute('title');
			map.identify({
					'coordinate': param,
					'layers': [map.getLayers()[getdrawlayer()]]
				},
				function(geos) {
					if (geos.length === 0) {
						return;
					}
					geos.forEach(function(g) {
						g.updateSymbol({
							'lineColor': color,
							'lineJoin': 'round',
							//miter, round, bevel
							'lineCap': 'round',
							//butt, round, square
						});
					});
				});
		});

	}

	function add_event(param) {
		$('.editor').on("touchstart", function() {
			if (box_show) {
				return;
			}
			box_show = true;
			point_editor(param);
		});
		//点击关闭隐藏标注，隐藏标注编辑
		$('.maptalks-close').on("touchstart", function() {
			hide_pointBox();
		});
	}
	//标点编辑
	function point_editor(param) {
		if (point_box) {
			point_box.remove();
		}
		point_box = new maptalks.ui.UIMarker([param.x, param.y], {
			'draggable': false,
			'single': false,
			'dx': 0,
			'dy': pointY,
			'content': '<div class="edit_sign_div"><div class="edit_sign_div_inner"><div class="marker_icon_list"><div class="marker_icon_inline marker_icon marker_icon_0"><img src="https://cdn.17ditu.com/static/images/location/location.png"/></div><div class="marker_icon_inline marker_icon marker_icon_1"><img src="https://cdn.17ditu.com/static/images/location/location1.png"/></div><div class="marker_icon_inline marker_icon marker_icon_2"><img src="https://cdn.17ditu.com/static/images/location/location2.png"/></div><div class="marker_icon_inline marker_icon marker_icon_3"><img src="https://cdn.17ditu.com/static/images/location/location3.png"/></div><div class="marker_icon_inline marker_icon marker_icon_4"><img src="https://cdn.17ditu.com/static/images/location/location4.png"/></div><div class="marker_icon_inline marker_icon marker_icon_5"><img src="https://cdn.17ditu.com/static/images/location/location5.png"/></div><div class="marker_icon_inline marker_icon marker_icon_6"><img src="https://cdn.17ditu.com/static/images/location/location6.png"/></div><div class="marker_icon_inline marker_icon marker_icon_7"><img src="https://cdn.17ditu.com/static/images/location/location7.png"/></div><div class="marker_icon_inline marker_icon marker_icon_8"><img src="https://cdn.17ditu.com/static/images/location/location8.png"/></div><div class="marker_icon_inline marker_icon marker_icon_9"><img src="https://cdn.17ditu.com/static/images/location/location9.png"/></div><div class="marker_icon_inline marker_icon marker_icon_10"><img src="https://cdn.17ditu.com/static/images/location/location10.png"/></div><div class="marker_icon_inline marker_icon marker_icon_11"><img src="https://cdn.17ditu.com/static/images/location/location11.png"/></div><div class="marker_icon_inline marker_icon marker_icon_12"><img src="https://cdn.17ditu.com/static/images/location/location12.png"/></div><div class="marker_icon_inline marker_icon marker_icon_13"><img src="https://cdn.17ditu.com/static/images/location/location13.png"/></div><div class="marker_icon_inline marker_icon marker_icon_14"><img src="https://cdn.17ditu.com/static/images/location/location14.png"/></div><div class="marker_icon_inline marker_icon marker_icon_15"><img src="https://cdn.17ditu.com/static/images/location/location15.png"/></div><div class="marker_icon_inline marker_icon marker_icon_16"><img src="https://cdn.17ditu.com/static/images/location/location16.png"/></div><div class="marker_icon_inline marker_icon marker_icon_17"><img src="https://cdn.17ditu.com/static/images/location/location17.png"/></div><div class="marker_icon_inline marker_icon marker_icon_18"><img src="https://cdn.17ditu.com/static/images/location/location18.png"/></div><div class="marker_icon_inline marker_icon marker_icon_19"><img src="https://cdn.17ditu.com/static/images/location/location19.png"/></div><div class="marker_icon_inline marker_icon marker_icon_20"><img src="https://cdn.17ditu.com/static/images/location/location20.png"/></div><div class="marker_icon_inline marker_icon marker_icon_20"><img src="https://cdn.17ditu.com/static/images/location/icon_marka.png"/></div><div class="marker_icon_inline marker_icon marker_icon_20"><img src="https://cdn.17ditu.com/static/images/location/icon_markb.png"/></div><div class="marker_icon_inline marker_icon marker_icon_20"><img src="https://cdn.17ditu.com/static/images/location/icon_markc.png"/></div><div class="marker_icon_inline marker_icon marker_icon_20"><img src="https://cdn.17ditu.com/static/images/location/icon_markd.png"/></div><div class="marker_icon_inline marker_icon marker_icon_20"><img src="https://cdn.17ditu.com/static/images/location/icon_marke.png"/></div><div class="marker_icon_inline marker_icon marker_icon_20"><img src="https://cdn.17ditu.com/static/images/location/icon_markf.png"/></div><div class="marker_icon_inline marker_icon marker_icon_20"><img src="https://cdn.17ditu.com/static/images/location/icon_markg.png"/></div></div></div><div class="to_left_tria"></div><i class="fa fa-close pointclose" style="position:absolute;right:5px;top:2px;font-size:18px;"></i></div>'
		});
		if (pointY == 50) {
			pointY = 120;
		}
		point_box.addTo(map).show();
		$('.pointclose').on("touchstart", function() {
			box_show = false;
			point_box.hide();
		});

		$('.marker_icon_inline img').on("touchstart", function() {
			var _this = this;

			map.identify({
					'coordinate': param,
					'layers': [map.getLayers()[getdrawlayer()]]
				},
				function(geos) {
					if (geos.length === 0) {
						return;
					}
					geos.forEach(function(g) {
						g.updateSymbol({
							'markerFile': _this.getAttribute('src'),
						});
					});
				}
			);
		});
	}
}

function getdrawlayer() {
	var layer = 0;
	for (var x = 0; x < map.getLayers().length; x++) {
		if (map.getLayers()[x]._geoList && map.getLayers()[x]._geoList.length != 0) {
			layer = x;
			break;
		}
	}
	return layer;
}

var app = angular.module("myApp", []);
app.controller("myCtrl", function($scope) {

	//获取热门城市
	$.post(request + "/dituapi/tool/gethotcity", {},
		function(result) {
			var res = JSON.parse(result);
			$scope.$apply(function() {
				$scope.hotcity = res.hotcity
				$scope.provinceList = res.provinceList
				$scope.asia = res.asia
				$scope.namerican = res.namerican
				$scope.samerican = res.samerican
				$scope.europe = res.europe
				$scope.africa = res.africa
				$scope.oceania = res.oceania
				$scope.antarctica = res.antarctica
			});
		});
	$scope.getArea = function(id) {
		areaId = id;
		isDirectOpen = 1;
		$.ajax({
			type: "post",
			url: request + "/dituapi/tool/getarea",
			async: true,
			data: {
				areaId: id
			},
			success: function(data) {
				var res = JSON.parse(data);
				res = res.city;
				$scope.$apply(function() {
					$('.curlist').show();
					$scope.citylist = JSON.parse(data).lists;
				});
				$('.areaselect').removeClass('show');
				if (res.coordinates) {
					coordinates = JSON.parse(res.coordinates);
				} else {
					coordinates = [];
				}
				currentX = res.lng;
				cityName = res.name
				lng = currentX;
				currentY = res.lat;
				if (cityName.indexOf('市') != -1) {
					currentZ = res.zoom * 4 + 0;
				} else {
					currentZ = res.zoom * 4 + 2;
				}

				if (res.parent_id <= 6 && res.parent_id != 0) {
					currentZ = res.zoom * 4 - 2;
				}
				coord = new maptalks.Coordinate(currentX, currentY);
				var b = new Base64();
				mapurl = currentX + "#" + currentY + "#" + currentZ
				ms = b.encode(mapurl);
				map.animateTo({
					center: [currentX, currentY],
					zoom: currentZ
				}, {
					duration: 2000
				});
				if (coordinates && coordinates != "" && coordinates != "null") {
					coordpolygon = new maptalks.Polygon(coordinates, {
						visible: true,
						editable: true,
						cursor: 'pointer',
						shadowBlur: 0,
						shadowColor: 'black',
						draggable: false,
						dragShadow: false,
						// display a shadow during dragging
						drawOnAxis: null,
						// force dragging stick on a axis, can be: x, y
						symbol: {
							'lineColor': '#00BFFF',
							'lineWidth': 5,
							'polygonFill': '#FF7F24',
							'polygonOpacity': 0
						}
					});
					if (map.getLayer('地区边界')) {
						map.getLayer('地区边界').remove();
					};
					coordlayer = new maptalks.VectorLayer('地区边界', coordpolygon).addTo(map);
					coordshow = false;
					$('#showarea').show();
					$('#showarea')[0].nextElementSibling.style.display = 'inline';
					$('#showarea').removeAttr('checked');
					coordpolygon.flash(500, //flash interval in ms
						3, // count
						function() { // callback when flash end
							coordlayer.hide();
							if (lng != "") {
								var positionTips = {
									'title': '当前位置',
									'content': cityName,
									'autoOpenOn': '',
									'width': 200
								};
								var infoWindow = new maptalks.ui.InfoWindow(positionTips);
								infoWindow.addTo(map).show(coord);
							};
						});
					coordinates = null;
					lng = "";
				} else {
					if (lng != "") {
						var positionTips = {
							'title': '当前位置',
							'content': cityName,
							'autoOpenOn': '',
							'width': 200
						};
						var infoWindow = new maptalks.ui.InfoWindow(positionTips);
						infoWindow.addTo(map).show(coord);
					};
				};
			}
		});
	}
	//获取配置地图
	$.post(request + "/dituapi/tool/getappmap", {},
		function(result) {
			var res = JSON.parse(result);
			$scope.$apply(function() {
				$scope.satellite = res.satellite;
				$scope.roadmap = res.roadmap;
				$scope.topographic = res.topographic;

			});
			
		});
});
var layerIndex;

function addFavorite() {
	if (issetshow) {
		issetshow = false;
		$('.dituset').hide();
	}
	if (usertype == 0) {
		layer.confirm('添加收藏需要登录,现在登录？', {
			btn: ['去登录', '算了'] //按钮
		}, function() {
			window.location.href = "..../user/login.html.html";
		}, function() {

		});
		return;
	}
	layerIndex = layer.open({
		type: 1,
		area: ['345px', '160px'],
		shade: 0.4,
		title: '加入收藏',
		anim: 3,
		shadeClose: true,
		//开启遮罩关闭
		closeBtn: false,
		content: '<div class="panel-body">' +
			'<div class="form form-horizontal" style="padding:10px;">标题: <input type="text" class="form-control" placeholder="请输入收藏标题(不能为空)" name="title" style="width:80%;" id="input-title" nullmsg="请输入收藏标题！">' +
			'<div class="cl"  style="text-align:center;padding-top:20px" >' +
			'<input class="btn btn-primary radius"  type="button" value="加入收藏" onclick="addToFavorite()" style="width:100px">' +
			'<input class="btn btn-danger radius " type="button" onclick="layer.close(layerIndex)" value="关闭" style="margin-left:20px">' +
			'</div>' + '</div>' + '</div>' + '</div>'
	});
};

function addToFavorite() {
	var title = document.getElementById('input-title').value;
	var desp = "";
	if (title == "") {
		document.getElementById('input-title').focus();
		layer.tips('收藏标题不能为空!', '#input-title', {
			tips: [1, '#3595CC'],
			time: 2000
		});
		return;
	};
	var index = layer.load(1, {
		shade: [0.1, '#fff'] //0.1透明度的白色背景
	});
	var addr = currentX + "#" + currentY + "#" + currentZ;
	var b = new Base64();
	ms = b.encode(addr);

	var addurl = "/?mt=" + currentMapId + "&ms=" + ms;

	$.ajax({
		type: "post",
		url: request + "/user/favorite/add",
		async: true,
		data: {
			"url": addurl,
			"title": title,
			"description": desp,
			token: token
		},
		xhrFields: {
			withCredentials: true
		},
		crossDomain: true,
		success: function(result) {

			if (result == "success") {
				layer.close(layerIndex);
				layer.close(index);
				layer.msg('加入收藏成功!', {
					icon: 1
				});
			} else if (result == "10") {
				layer.close(layerIndex);
				layer.close(index);
				layer.msg('非VIP用户最多只能收藏10条记录!', {
					icon: 0
				});
			} else {
				layer.close(layerIndex);
				layer.close(index);
				layer.msg('收藏失败!', {
					icon: 0
				});
			}
		}
	})
};
function changelng(){
	if(islng){
		islng = false;
		var x = changeFromlnglat(currentX,true);
		$("#centerX").text(x);
		var y = changeFromlnglat(currentY,false);
		$("#centerY").text(y);
	}else{
		islng = true;
		$("#centerX").text(currentX);
		$("#centerY").text(currentY);
	}
}



function changeFromlnglat(lnglat,islngorlat){
	var str1 = lnglat.split(".");
	var du1 = str1[0];
	if (!isRealNum(du1)) {
		du1 = 0;
	}
	var tp = "0." + str1[1];
	var tp = String(tp * 60);
	var str2 = tp.split(".");
	
	var fen = str2[0];
	if (!isRealNum(fen)) {
		fen = 0;
	}
	
	tp = "0." + str2[1];
	tp = tp * 60;
	var miao = tp;
	if (!isRealNum(miao)) {
		miao = 0;
	};
	var str = "E";
	if(islngorlat){
		if(du1*1 < 0){
			du1 = du1*1 * -1;
			str = 'W';
		}
	}else{
		if(du1 * 1 > 0){
			str = "N";
		}else{
			du1 = du1*1 * -1;
			str = "S";
		}
	}
	if(du1 == "-0"){
		du1 = 0;
	}
	miao = miao.toFixed(0);
	var res = du1 + "°" + fen + "′" + miao + "″" + str;
	
	return res;
}
function isRealNum(val) {
	// isNaN()函数 把空串 空格 以及NUll 按照0来处理 所以先去除
	if (val === "" || val == null) {
		return false;
	};
	if (!isNaN(val)) {
		return true;
	} else {
		return false;
	};
};

function setCookie(name, value) {
	window.localStorage.setItem(name, value);
	return;
}

function plusReady() {
	if (plus.os.name == 'Android') {
		isos = false;
	} else {
		isos = true;
	}
}

document.addEventListener('plusready', plusReady, false);
// str=str.replace(/./, '')
function updateversion() {
	
	$.ajax({
		type: "post",
		url: request + "/user/profile/version",
		async: true,
		success: function(data) {
			data = JSON.parse(data);

			var hotversion = 0;
			if (data['hot_version']) {
				hotversion = data['hot_version'].replace(/\./g, '') * 1;
			}
			var apkversion = 0;
			if (data['version']) {
				apkversion = data['version'].replace(/\./g, '') * 1;
			}
			
			var currentversion = cversion.replace(/\./g, '') * 1;

			if (hotversion * 1 < 100) {
				hotversion = hotversion * 10;
			}
			if (apkversion * 1 < 100) {
				apkversion = apkversion * 10;
			}
			if (currentversion * 1 < 100) {
				currentversion = currentversion * 10;
			}
			if (hotversion * 1 < 1000) {
				hotversion = hotversion * 10;
			}
			if (apkversion * 1 < 1000) {
				apkversion = apkversion * 10;
			}
			if (currentversion * 1 < 1000) {
				currentversion = currentversion * 10;
			}
			
			if (hotversion <= apkversion || hotversion - currentversion >= 100) {
				if (data['version'] == 0) {

				} else {
					if (apkversion <= currentversion) {

					} else {
						if (getCookie('version') * 1 >= apkversion) {
							return;
						}
						var btn = ['去升级'];
						if(data.is_hot){
							btn = ['去升级','算了'];
						}
						data.descript = data.descript.replace(/\n/g, '<br/>');
						var versionwin = layer.confirm(data.descript, {
							btn: btn,
							title: '版本更新'
						}, function() {
							$('.downlaodapp').show();
							createDownload(data.link, 'downlaodapp');
							layer.closeAll();
						}, function() {
							setCookie('version', apkversion);
						});
					}
				}
			} else {
				if (data['hot_version'] == 0) {

				} else {
					if (hotversion <= currentversion || hotversion - currentversion >= 100) {

					} else {

						var btn = ['去升级'];
						
						data.hot_descript = data.hot_descript.replace(/\n/g, '<br/>');
						var versionwin = layer.confirm(data.hot_descript, {
							btn: btn,
							title: '版本更新'
						}, function() {
							$('.downlaodapp').show();
							
							downWgt(data.wgturl_android, 'downlaodapp');
							layer.closeAll();
							$.ajax(request + '/user/profile/updatedownload',{
								data:{
									'ios':0,
									'id':data.id
								},
								dataType:'json',//服务器返回json格式数据
								type:'post',//HTTP请求类型
								async: true,
								success:function(data){
									
								},
								error:function(xhr,type,errorThrown){
									
								}
							});
						}, function() {

						});
					}
				}
			}

		}
	});
}

function getCookie(name) {
	return window.localStorage.getItem(name);
};

//热更新
function downWgt(url, loadid) {
	
	dtask = plus.downloader.createDownload(url);
	dtask.addEventListener("statechanged", function(download, status) {
		var progress = download.downloadedSize / download.totalSize * 100;
		if (download.state == 4 && status == 200) {
			del();
			$('.downlaodapp').hide();
			installWgt(download.getFileName());
		} else {
			progress = parseInt(progress.toFixed(2));
			if (isNaN(progress)) {
				document.getElementById(loadid).innerHTML = "开始下载";
			} else if (progress == 100) {
				del();
				document.getElementById(loadid).innerHTML = "下载完成";
			} else {
				document.getElementById(loadid).innerHTML = '更新中' + progress + '%';
				$('#downlaodappbox div p')[0].style.width = progress + '%';
			}
		}
	}, false);
	dtask.start();
}

function installWgt(path) {
	plus.nativeUI.showWaiting("安装更新文件...");
	plus.runtime.install(path, {}, function() {
		plus.nativeUI.closeWaiting();
		plus.nativeUI.alert("应用资源更新完成！", function() {
			plus.runtime.restart();
		});
	}, function(e) {
		plus.nativeUI.closeWaiting();
		plus.nativeUI.alert("安装更新文件失败[" + e.code + "]：" + e.message);
		if (e.code == 10) {
			alert('请清除临时目录');
		}
	});
}


/*  
 * 创建下载任务  
 */

function createDownload(url, loadid) {
	dtask = plus.downloader.createDownload(url);
	dtask.addEventListener("statechanged", function(download, status) {
		var fimename = download.getFileName().slice(11).replace('.apk', '');
		var progress = download.downloadedSize / download.totalSize * 100;
		if (download.state == 4 && status == 200) {
			del();
			plus.nativeUI.confirm("下载已完成，是否安装？", function(e) {
				if (e.index == 0) {
					$('.downlaodapp').hide();
					openFile(download.getFileName());
				} else {
					$('.downlaodapp').hide();
					del();
				}
			}, fimename, ["确定", "取消"]);
		} else {
			progress = parseInt(progress.toFixed(2));
			if (isNaN(progress)) {
				document.getElementById(loadid).innerHTML = "开始下载";
			} else if (progress == 100) {
				del();
				document.getElementById(loadid).innerHTML = "下载完成";
			} else {
				document.getElementById(loadid).innerHTML = '更新中' + progress + '%';
				$('#downlaodappbox div p')[0].style.width = progress + '%';
			}
		}
	}, false);
	dtask.start();
}

/*  
 * 暂停下载任务  
 */
function pauseDownload() {
	dtask.pause();
}
/*  
 * 恢复下载任务  
 */
function resumeDownload() {
	dtask.resume();
}
/*  
 * 取消下载  
 */
function del() {
	plus.downloader.clear();
}

/*  
 * 打开文件操作  
 */
function openFile(fileName) {
	plus.runtime.openFile(fileName);
}

function currentDec() {
	var cof = syncXHR('https://cdn.17ditu.com/static/fgis/v2/js/WMM.COF');
	var newGeomag = new Geomag(cof);
	var geoMag = newGeomag.mag;
	myGeoMag = geoMag(currentY, currentX, 0);
	return myGeoMag.dec.toFixed(5);
};

function crosslineRotate() {
	var rotate = $("#rotatenum").val();
	if (isRealNum(rotate)) {
		luopanCrossMarker.updateSymbol({
			'markerRotation': luopanCrossMarker.getSymbol().markerRotation - Number(rotate)
		});
	} else {
		layer.msg('请输入数字！');
	}
};

function isRealNum(val) { // isNaN()函数 把空串 空格 以及NUll 按照0来处理 所以先去除

	if (val === "" || val == null) {
		return false;
	}
	if (!isNaN(val)) {
		return true;
	} else {
		return false;
	}
};

function resetdir() {
	map.setBearing(0);
	updateMoving()
};

function getshorturl(lurl) {
	var shorturl = "";
	$.ajax('https://www.17ditu.com/dituapi/tool/shorturl', {
		data: {
			url: lurl
		},
		dataType: 'json', //服务器返回json格式数据
		type: 'get', //HTTP请求类型
		async: false,
		success: function(data) {
			var data = JSON.parse(data);
			if (data.Code == 0) {
				shorturl = data.ShortUrl;
			} else {
				shorturl = lurl;
			}
		},
		error: function(xhr, type, errorThrown) {
			shorturl = lurl;
		}
	});
	return shorturl;
}

function resetluopan() {
	luopanCrossMarker.updateSymbol({
		'markerRotation': 0
	});
}
